#!/bin/csh -f
 
source $1

set tlsin = ''
set libin = ''
set restrcyc = 50
set restrref = 5
set wmat = AUTO
set weightv =  
set models = 1
set whichtrace = 1
set tlsonoff = 0
set solvent = 0
set flatten = 0
set freebuild = 0
set scanis = Y 
set scaleopt = " $scale LSSC ANIS "
set refmax = MLKF 
set refmeth = CGMAT 
set freer = $EXCLUDE_FREER 
set freerml = $EXCLUDE_FREER
set phaseres = N 
set phasblur = 1.0 
set cycskip = 0 
set skip = 0 
set flagk = 1 
set truncshifts = 1 
set multit = 5 
set upmore = 1 
set side = 0 
set fsig = 3.2 
set newrefmac = 1 
set flagf = 0 
set randtimes = 0 
set rand1 = 0 
set randshift1 = 0.5 
set bcut1 = 2.0 
set rand2 = 0 
set randshift2 = 0.5 
set bcut2 = 2.0 
set rand3 = 0 
set randshift3 = 0.5 
set bcut3 = 2.0 
set keepdata = WORLD 
set remote = 0 
set arpwarpdir = temp
set remoteemail =   
set WORKDIR = `pwd`
set JOB_ID = 1
setenv boldon "tput bold"
setenv boldoff "tput rmso"
set filesloc = `pwd`/files/
@ dcreslast = 0
@ creslast = 0
@ rlast = 10
@ rfree_rfree = 10
#
if ( $ncs_num > 1 ) then
set protsize = `echo $seq_num $ncs_num | awk '{print $1*$2*8;}'`
else
set protsize = `echo $seq_num | awk '{print $1*8;}'`
endif


if ( $modeccp4i == WARPNTRACEMODEL ) then
 set REF_MODE = REFML
endif

#echo "##################################################" >> /home/ztony/oasis_arp.log
#echo "$JOB_ID" >> /home/ztony/oasis_arp.log
#echo "##################################################" >> /home/ztony/oasis_arp.log

if ( $modeccp4i == WARPNTRACEMODEL ) then
  set REF_MODE = REFML
  set phibest = Unassigned
endif

rm -fr ${WORKDIR}/oasis_arp.mtz
cp $datafile ${WORKDIR}/oasis_arp.mtz
set datafile = "${WORKDIR}/oasis_arp.mtz"
if ( $EXCLUDE_FREER == "Y" ||  $arp_select_mode == "rfree" || $select_mode == "rfree" ) then
	set freelabin = " FREE=$RFREE "
	set scalml = ' SCAL MLSC FREE '
	set rfree_signal = 1
else
	set rfree_signal = 0
	set freelabin = '  '
	set scalml = ' SCAL MLSC '
endif
###
if ( $REF_MODE == "REFML" ) then
	set phaselabin = '   '
	set phaseref = '   '
else
        set damp = ' 0.4  0.4 '
	set phaselabin = " PHIB=$phibest FOM=$fom  "
	set phaseref = '  PHAS SCBL 1.0 '
endif

if ( $hl_signal == 1 ) then
  	set phaselabin = " HLA=$HLA HLB=$HLB HLC=$HLC HLD=$HLD  "
endif

mtzdump hklin ${datafile} > ${WORKDIR}/mtz_dump.log <<EOF
NREF 0
GO
EOF

set resol = `awk '/Resolution Range/,/Sort Order/' ${WORKDIR}/mtz_dump.log | awk '(NF==8) { if ($4 < 20.0) print $4,$6 ; else print '20.0', $6 }'`
set res = `awk '/Resolution Range/,/Sort Order/' ${WORKDIR}/mtz_dump.log | awk '(NF==8) { print $4,$6}'`
set damp = ` echo $res | awk '{ if ( $2 > 2.00 ) print " 0.4  0.4 "; else print " 0.99  0.99 "}' `
set rrcyc = ` echo $res | awk '{ if ( $2 > 2.00 ) print "3"; else print "1"}' `
set rsig = ` echo $res | awk ' { if ( $2 > 2.00 ) printf"%.2f",(($2 - 2.8)*($2 - 2.8)+1)*0.6+0.005 ; else print "1.0" }' `
set rsig = ` echo $res' '$rsig | awk '{ if ( $2 > 2.80 ) print "0.6";else print $3}' `
#

$warpbin/arp_warp > ${WORKDIR}/arp_aulim_extract.log <<EOF
MODE MIRBUILD
SYMM $sym
END
EOF
#
set xlim = `grep 'Asymmetric unit limits' ${WORKDIR}/arp_aulim_extract.log |awk '{printf"%.4f", $4/$6+0.000049}' | sed 's/\,/\./' `
set ylim = `grep 'Asymmetric unit limits' ${WORKDIR}/arp_aulim_extract.log |awk '{printf"%.4f", $7/$9+0.000049}' | sed 's/\,/\./'`
set zlim = `grep 'Asymmetric unit limits' ${WORKDIR}/arp_aulim_extract.log |awk '{printf"%.4f", $10/$12+0.000049 }' | sed 's/\,/\./'`
#

set xyzlim = "  0.0 $xlim 0.0 $ylim 0.0 $zlim  "

set fuse = $fp

#echo $xyzlim

#echo $resol $res $damp $rrcyc $rsig
#

$warpbin/arp_warp > ${WORKDIR}/arp_wilson.log <<EOF
MODE WILSON NRES $seq_num
FILES CCP4 HKLIN $datafile
RESOLUTION $resol
LABELS FP=${fp} SIGFP=${sigfp} FUSE=${fuse}
END
EOF
#

set wilsonb = `grep 'Bfactor' ${WORKDIR}/arp_wilson.log | awk '{printf "%.1f",int($4+0.99999)} '`
set solventc = `grep 'Solvent content' ${WORKDIR}/arp_wilson.log | awk '{printf "%.2f",$3+0.001} '`
echo $wilsonb $solventc

#########################################
#########################################
ccp4istart:
#########################################
######################################### 
#
set lastprog = MAIN_SCRIPT
set boldon  = '<B><FONT COLOR="#FF0000"><\!--SUMMARY_BEGIN-->'
set boldoff = '<\!--SUMMARY_END--></FONT></B>'
#
# Sourcing the parameter file
echo 'The parameter file is:' $1
echo 
#
#
# RUN_Locally
#
echo $boldon
if ( $remote == "1" ) then
  echo 'The ARP/wARP job will run on the EMBL Hamburg 16-processor cluster'
endif
echo 
echo 'Entering arp_warp.sh from the CCP4I interface'
echo $boldoff
echo 
#
# First make sure we are where we are supposed to be !
#
if ( $remote != "1" ) then
  echo 'The working directory is:' ${WORKDIR}
endif
#
if ( -e $WORKDIR ) then
    cd $WORKDIR
else
    echo 'Run directory does not exist on that computer '
    goto exitlab
endif
#
echo 'ARP/wARP will run in the subdirectory:' $arpwarpdir
#
# That will make the main run directory for this one ...
#
if ( -e $arpwarpdir ) /bin/rm -f -r $arpwarpdir
#
mkdir $arpwarpdir
#

#

cd $arpwarpdir
#
# Add the warp.par as log file here ...
#
#
# This sets the arpwarpmode to be same as text based scripts
#
if ( $modeccp4i == 'WARPNTRACEPHASES' || $modeccp4i == 'WARPNTRACEMODEL' ) set arpwarpmode = warpNtrace
if ( $modeccp4i == 'MOLREP' ) set arpwarpmode = molrep
if ( $modeccp4i == 'FREEATOMS' ) set arpwarpmode = warp
if ( $modeccp4i == 'SOLVENT' ) set arpwarpmode = solvent
#
#

#
set keepzero = ''
set rsfitwater = ''
set restr = 'RESTR'
set weight = ${wmat}
#
set rh = `echo $resol | awk '{print $2}'`
set rrsig = `echo $rsig | awk '{print $1 + 0.4}'`
set ffsig = `echo $fsig | awk '{print $1 + 0.4}'`
#
if ( $newrefmac == 1 && $arpwarpmode != 'solvent' ) then 
    set freename = 'DUM' 
else
    set freename = 'WAT'
endif
#
set extralib = ''
#

if ( ${tlsin} != '' ) then
    set tlsinfile = ${tlsin}
else
    set tlsinfile = ''
    set tlsin = ''
    set tlslab = ''
endif
#
if ( ${solvent} == '1' ) then
    set bsolvent = 'SOLVENT YES'
else
    set bsolvent = ''
endif
#
if ( $arpwarpmode == 'warpNtrace') then
    set arpmode = 'allatoms'
    set mergedist = 0.7
    set cindex = 1
    set tlsinfile = 'init.tls'
    set tlslab = ''
    set tlsin = ''
endif
#
#
if ( $arpwarpmode == 'solvent' ) then
    set rsfitwater = `echo $rh | awk '{if ($1>2.2) print " "} {if ($1<2.2001)  print "REFINE WATERS"}'`
    set arpmode = 'waters'
    set mergedist = '2.2'
    set lastfb = ''
    set restrcyc = ${restrref}
    if ( $libin != "" ) then 
	set extralib = 'LIBIN '${libin}
    endif    
endif
#

if ( $arpwarpmode == 'warp' ) then
    set restr = 'UNRESTR'
    set arpmode = 'allatoms'
    set mergedist = 0.7
    set lastfb = ''
    set restrcyc = ${restrref}
    set keepzero = 'KEEPZEROOCC ALLATOMS'
endif

#
if ( $arpwarpmode == 'molrep' ) then
    set arpmode = 'allatoms'
    set mergedist = 0.7
    set lastfb = ''
    set restrcyc = ${restrref}
    set keepzero = 'KEEPZEROOCC ALLATOMS'
endif
#
if ( $modeccp4i == 'WARPNTRACEPHASES' && $skip != 0 ) set restr = 'UNRESTR'
#
if ( flagf == 1) set arpmode = 'waters'
#
# Decide name for the running directory and go there ...!
# Largely UNneccessary for ccpish but kept for compatibility ...!
#
set filesloc = ${WORKDIR}/${JOB_ID}_
#
#
#===================================
# Setup logfiles and few more params
#===================================
#
set prefix = ${arpwarpmode}
#
#
set logf = ${WORKDIR}/${JOB_ID}_${prefix}_refine.log
set lastf = ${WORKDIR}/${JOB_ID}_${prefix}_refine.last.log
set tabf = ${WORKDIR}/${JOB_ID}_${prefix}_refine.loggraph
#

echo 
#
if ( $arpwarpmode == 'warpNtrace') then
    set logfb = ${WORKDIR}/${JOB_ID}_${prefix}_build.log
    set lastfb = ${WORKDIR}/${JOB_ID}_${prefix}_build.last.log
    set tabfb = ${WORKDIR}/${JOB_ID}_${prefix}_build.loggraph
    set logomega = ${WORKDIR}/${JOB_ID}_${prefix}_omega.log
endif
#
if ( flagf == 1) set arpmode = 'waters'
#
if ( -e $logf ) /bin/rm -f $logf
if ( -e $lastf ) /bin/rm -f $lastf
if ( -e $tabf ) /bin/rm -f $tabf
touch $logf

touch $lastf
touch $tabf
if ($arpwarpmode == 'warpNtrace') then
    if ( -e $logfb ) /bin/rm -f $logfb
    if ( -e $lastfb ) /bin/rm -f $lastfb
    if ( -e $tabfb ) /bin/rm -f $tabfb
    touch $logfb
    touch $lastfb
    touch $tabfb


#
#
#===========================================================
#
# Prepare the start files here ... one way or the other ...
#

if ( $modeccp4i == 'WARPNTRACEPHASES' ) then

    echo $boldon
    echo 'Building free atoms model.'
    echo $boldoff
#warp_building


set lastprog = MAIN_SCRIPT
/bin/echo 'NOTOK' >stat.temp
    if ( $models > 3 ) set models = 3
    set logf =  ${WORKDIR}/${JOB_ID}_warp_build.log
    set tempfilesloc = ${WORKDIR}/${arpwarpdir}/${JOB_ID}_
    set filesloc = ${WORKDIR}/${JOB_ID}_
set lastlogfile = $logf
#
if ( ${?eresol} == 0 ) set eresol = 1.2
if ( $eresol == '' ) set eresol = 1.2
#
# Here we cheat fft by supplying false resolution to get desired grid.
# fft will thus use maximum resolution for fft , but very fine grid of ~0.333 A !
#
if ( $fom == '' ) then
#
set lastprog = CAD
#
# cad anyhow a new file ....
# If exp. phases resolution cutoff is given then resol will be cutoff ...
cad hklin1 ${datafile} hklout ${tempfilesloc}temp.cad > ${logf} <<EOF
RESOL OVER_ALL 20 ${eresol}
LABIN FILE 1 E1=$fbest E2=$phibest
CTYPIN FILE 1 E1=F E2=P
LABOUT E1=$fbest E2=$phibest
END
EOF
#
if ($status) goto exitlab
#
set lastprog = FFT
#
fft hklin ${tempfilesloc}temp.cad mapout ${tempfilesloc}temp.map >>  ${logf} <<EOF
LABIN F1=$fbest PHI=$phibest
RESOL 20 1.2
END
EOF
#
if ($status) goto exitlab
#
/bin/echo ' Initial map calculated with ALREADY weighted amplitude ...'
#
else
#
set lastprog = CAD
#
cad hklin1 ${datafile} hklout ${tempfilesloc}temp.cad >>  ${logf} <<EOF
RESOL OVER_ALL 20 ${eresol}
LABIN FILE 1 E1=$fbest E2=$phibest  E3=$fom
CTYPIN FILE 1 E1=F E2=P E3=W
LABOUT E1=$fbest E2=$phibest  E3=$fom
END
EOF
#
if ($status) goto exitlab
#
set lastprog = FFT
#
fft hklin ${tempfilesloc}temp.cad mapout ${tempfilesloc}temp.map >>  ${logf} <<EOF
LABIN F1=$fbest PHI=$phibest W=$fom
RESOL 20 1.2
END
EOF
#
if ($status) goto exitlab
/bin/echo ' Initial map calculated, amplitude weighted by extra weight ...'
#
endif
#
set lastprog = MAPMASK
#
mapmask mapin ${tempfilesloc}temp.map mapout ${tempfilesloc}arp_in.map >> ${logf} <<EOF
XYZLIM ${xyzlim}
EOF
#
if ($status) goto exitlab
#
/bin/rm ${tempfilesloc}temp.map
/bin/echo ' ... and extended to AU'
#
/bin/echo ' Now building '$models' initial model(s)'
# 
#
set lastprog = ARP_WARP_BUILD
#
#
if ( $newrefmac == 1) then 
    set freename = 'DUM' 
else
    set freename = 'WAT'
endif
#

$warpbin/arp_warp >> ${logf} <<EOF
MODE MIRBUILD
FILES CCP4 MAPFIND ${tempfilesloc}arp_in.map XYZOUT1 ${filesloc}mir_model_1.pdb XYZOUT2 ${filesloc}mir_model_2.pdb XYZOUT3 ${filesloc}mir_model_3.pdb
SYMM ${sym}
CELL ${cell}
RESOLUTION ${resol}
MIRBUILD ATOMS $protsize MODELS ${models} RESN $freename
END
EOF
#
if ($status) goto exitlab
#
# Printout if there is a cell difference
set celldiff = `grep "Cells differ:" ${logf} | wc -l | awk '{print $1}' `
if ( $celldiff != "0" ) then
/bin/echo $boldon
grep "Cells differ:" ${logf}
/bin/echo 
/bin/echo ' If you are using a muti-dataset MTZ file, there might be a confusion'
/bin/echo ' between the MASTER cell and other cells. The job will continue.'
/bin/echo ' However, please consider re-building the MTZ so that it contains one'
/bin/echo ' dataset only, and then re-submitting ARP/wARP.'
/bin/echo 
/bin/echo $boldoff
endif
#/bin/echo ' ...completed model(s). '
#
set lsig = `grep 'sigmas )' ${logf} | tail -1 | awk '{print $5}'`
#/bin/echo 
/bin/echo ' Had to go as low as '$lsig' sigma, to complete atoms search.'
/bin/echo 
#warp_building_end
    if ($status) goto exitlab

    cp ${filesloc}mir_model_1.pdb arp_0.pdb

    if ( -e ${tlsinfile} ) /bin/rm -f ${tlsinfile}
    touch ${tlsinfile}
    endif
  endif
#

if ( $modeccp4i == 'WARPNTRACEMODEL' ) then
    if ( $flagk == 1 ) then
	cp $modelin arp_0.pdb
	if ( -e ${tlsinfile} ) /bin/rm -f ${tlsinfile}
	touch ${tlsinfile}
    else 
$warpbin/reshuffle xyzin ${modelin} \
xyzout arp_0.pdb TLSOUT ${tlsinfile} >> ${logf}  <<e
MOLECU  ${cgr}
GRID 3
XYZLIM $xyzlim
SYMM  $sym
END
e
    endif
#
endif
#

if ( $tlsonoff != '1' ) then
    if ( -e ${tlsinfile} && ${tlsinfile} != ' ' ) /bin/rm -f ${tlsinfile}
endif
#
if ( $modeccp4i == 'MOLREP' ) then
cp ${modelin} arp_0.pdb
endif
#
#
if ( $modeccp4i == 'SOLVENT' ) then
cp ${modelin} arp_0.pdb
endif
#


echo 
#
# Set a few dependent parameters here ...
#
#
# this ... hmmm ... have to think.
set resetfreer = 0
# This enables the flattening ... also goes in mode 'from model'
#set flatten = 0
# this has to go on mode 'from model'
#set freebuild = 0
# This is for ncs on ... complicated
set ncs = 0
# This turn on expert mode
set reset = ''
#
#
# Done here as well with no real reason except stupid programming
#
set labout = 'FC=FC PHIC=ALPHA FWT=FWT PHWT=PHWT DELFWT=DELFWT PHDELWT=PHDELWT'
set labinfft21  = 'F1=FWT    PHI=PHWT'
set labinfft11  = 'F1=DELFWT PHI=PHDELWT'
#
#
endif
#
# Add standard report here !!!
#
#echo ' '
echo $boldon
if ( $newrefmac == "0" ) then
    echo '  ARP will be iterated with REFMAC 4.'
else
    echo '  ARP will be iterated with REFMAC 5.'
endif
echo '  '$restrcyc 'ARP refinement cycles will be run in total.'
#
echo '  Atoms will be removed if below '$rsig' sigmas in 2mFoDFc map.'
echo '  Atoms will be added if above '$fsig' sigmas in mFoDFc map.'
#
echo 
echo '  Refmac Refinement Parameters'

echo '    '${rrcyc}' REFMAC cycle(s) with '${damp}' fractional shifts damping in each ARP cycle.'
echo '    Weight for restraints is set to '$wmat' '${weightv}
if ( $freer == "Y" ) then
    if ( $freerml == "Y") then
	echo '    FreeR will be used for monitoring and sigmaa calculations.'
    else
	echo '    FreeR will only be used for monitoring.'
    endif
else
    echo '    FreeR will not be used.'
endif
if ( ${solvent} == '1' ) then
    echo '    Solvent mask correction will be used.'
endif

if ( $scale == 'BULK' ) then
    if ( $scanis == 'Y' ) then
	echo '    Anisotropic scaling with bulk solvent correction'
    else
	echo '    Simple scaling with with bulk solvent correction'
    endif
else
    if ( $scanis == 'Y' ) then
	echo '    Anisotropic scaling, NO bulk solvent correction'
    else
	echo '    Simple scaling, NO bulk solvent correction'
    endif
endif

if ( $tlsonoff == '1' ) then 
    echo '    TLS refinement will be performed.'
endif

echo 
    
if ($arpwarpmode == 'warpNtrace') then
    echo '  Autobuilding Parameters'

    echo '    Autobuilding will take place every '$restrref' ARP cycles.'
    if ( $side >= 0 ) then
	echo '    Side chain docking will be performed from autobuilding cycle number '$side 
    endif

    if ( $whichtrace == 0 ) then
	echo '    The Breadth first search (old) autobuilding algorithm will be used.'
    endif
    if ( $whichtrace == 1 ) then
	echo '    The Depth first search (NEW) autobuilding algorithm will be used.'
    endif
endif
	
#echo 

#echo '  ARP/wARP iteration flow parameters'

if ( $skip != 0 ) then
    echo '    Autobuilding will be skipped the first '$skip' times.'   
endif

if ( $freebuild == 1 && $flatten == 1 ) then
   echo '    In place of the first autobuilding, solvent flattening will be performed.'
   echo '    A free atoms model will be constructed in the solvent flattened map.'
endif
if ( $freebuild == 1 && $flatten == 0 ) then
   echo '    In place of the first autobuilding, a new free atoms model '
   echo '    will be constructed in the 2mFo-DFc refmac map.'
endif

if ( ${randtimes} >= 1 ) then
    echo '    In place of autobuilding cycle nr.'$rand1' random shifts of '$randshift1' will be applied.'
endif
if ( ${randtimes} >= 2 ) then
    echo '    In place of autobuilding cycle nr.'$rand2' random shifts of '$randshift2' will be applied.'
endif
if ( ${randtimes} == 3 ) then
    echo '    In place of autobuilding cycle nr.'$rand1' random shifts of '$randshift3' will be applied.'
endif

echo ' '
#
#
#
#echo 
echo     '================================================================================='
echo     '| Please cite the correct publication for the ARP/wARP application you are using|'
if ( $arpwarpmode == 'warpNtrace' ) then
    echo '| Perrakis A, Morris R and Lamzin VS                                            |' 
    echo '| Automated protein model building combined with iterative structure refinement.|'
    echo '| Nature Struct. Biol., 6:458-463, 1999.                                        |'
endif
if ( $arpwarpmode == 'solvent' ) then
    echo '| Lamzin VS and Wilson KS                                                       |'
    echo '| Automated refinement of protein models.                                       |'
    echo '| Acta Cryst., D49:129-149, 1993.                                               |'
endif
if ( $arpwarpmode == 'warp' ) then
    echo '| Perrakis A, Sixma TK, Wilson KS and Lamzin VS                                 |'
    echo '| wARP: improvement and extension of crystallographic phases                    |'
    echo '| by weighted averaging of multiple refined dummy atomic models.                |'
    echo '| Acta Cryst., D53:448-455, 1997. '
endif
if ( $arpwarpmode == 'molrep' ) then
    echo '| Perrakis A, Harkiolaki M, Wilson KS and Lamzin VS                             |'
    echo '| ARP/wARP and molecular replacement.                                           |'
    echo '| Acta Cryst. D57:1445-50, 2001.                                                |'
endif
echo     '================================================================================='
echo 
echo $boldoff
#
#
#
#
#######################################
mainstart:
#######################################
#
# Put some pre-ambles to the table file for loggraph
#
echo '$TABLE: Refinement statistics:' >>${tabf}
echo '$GRAPHS: Rfactor v. Cycle nr :N:1,2:' >>${tabf}
echo ': Rfactor and Rfree v. Cycle nr :N:1,2,3:' >>${tabf}
echo ': Working set refinement indicators v. Cycle nr :N:1,2,4,6:' >>${tabf}
echo ': Working and free set refinement indicators v. Cycle nr :N:1,2,3,4,5,6,7:' >>${tabf}
echo ': Atoms added and removed v. Cycle nr :N:1,8,9:' >>${tabf}
echo ': Bonds rms v. Cycle nr :N:1,11:' >>${tabf}
echo ': Angles rms v. Cycle nr :N:1,12:' >>${tabf}
echo '$$' >>${tabf}
echo '  Cycle Rfactor Rfree Fo_Fc_corr Fo_Fc_free_corr FOM free_FOM Atoms_add Atoms_remove Total_atoms Rms_bonds Rms_angles ' >>${tabf}
echo '$$' >>${tabf}
echo '  Cycle Rfactor Rfree Fo_Fc_corr Fo_Fc_free_corr FOM free_FOM Atoms_add Atoms_remove Total_atoms Rms_bonds Rms_angles ' >>${tabf}
echo '$$' >>${tabf}
#
#
#
if ( $arpwarpmode == 'warpNtrace' ) then
    echo '$TABLE: Building statistics:' >>${tabfb}
    echo '$GRAPHS: Connectivity index v. Cycle nr :N:1,4:' >>${tabfb}
    echo ': Fragments and residues v. Cycle nr :N:1,2,3,5,6:' >>${tabfb}
    echo '$$' >>${tabfb}
    echo '  Cycle Fragments Residues Connectivity_index DockedFragments DockedResidues' >>${tabfb}
    echo '$$' >>${tabfb}
    echo '  Cycle Fragments Residues Connectivity_index DockedFragments DockedResidues' >>${tabfb}
    echo '$$' >>${tabfb}
endif
#
#
#=========================
# Here is the main code 
#=========================
#
#
#
set name = 'arp_'
set last   =  0
#
set count  =   0 
set bigcount  =   0
#
#
# Here starts the cycling for the refinement/autobuilding
#
#
while ($count != $restrcyc)
#
#
if ( -e ${lastf} ) /bin/rm -f ${lastf}
#
@ next = $last + 1
#
# To start with see how much to add/remove in this cycle run
#
set rh = `echo $resol | awk '{print $2}'`
set goal = `echo $protsize $rh| awk '{print int($1*((0.2/($2*$2))+1.1))}'`
set rr = `echo $resol | awk '{print $2*$2*$2}'`
set atnow = `grep -c '  1.00 ' ${name}${last}.pdb `
set rh = `echo $rh |  awk '{if ($1>1.80) print 1.8} {if ($2 <= 1.80)  print $1}'` 
@ idealtofind = ( ${goal} - ${atnow} ) / ${restrref}
@ find = `echo $atnow $rr $upmore | awk '{printf"%4d\n",$3*0.08*$1/$2}'`
if ( $find == 0 ) set find = 3
if ( ${idealtofind} > ${find} ) @ find = ${idealtofind}
@ rem  = $find - ( $goal - $atnow ) / ${restrref}
@ ttt = $find / 2
if ( ${rem} < $ttt ) set rem = $ttt
if ( ${goal} < ${atnow} ) @ find = ${find} / 2 
if ( $arpwarpmode == 'solvent' ) set rem = $find
#
# Lets check now if this is AFTER the last autobuilding
# In that case mode goes from allatoms to waters
#
if ( $last > $restrcyc - $restrref && $flagf == 0 && $arpwarpmode == 'warpNtrace') then
  set flagf = 1
  set arpmode = 'waters'

  if ( $seqcovermode == "wat" ) then
    echo ' ---> Final restrained refinement block. Update only waters.'
    set rsfitwater = `echo $rh | awk '{if ($1>2.2) print " "} {if ($1<2.2001)  print "REFINE WATERS"}'`
    set mergedist = '2.2'
    set rsig = 1.0
    set rem = $find
    set freename = 'WAT'
  else
    echo ' ---> Final restrained refinement block. No atom update.'
    set rsig = -50.0
    set fsig = 50.0
  endif
endif
#
#
# Get rid of 0 atoms ...!
#
if ($arpwarpmode != 'warp' ) then
    grep -v ' 0.000   0.000' ${name}${last}.pdb > t1.tmp
    mv t1.tmp ${name}${last}.pdb
endif
#
#
@ lctemp = $last - 1 
# Look at freer for 'skip'
if ( $cycskip == $lctemp  && $resetfreer == 1) then
  set freer = Y
  set freerml = Y
  set freelabin = ''
  set scalml = 'SCAL MLSC WORK'
  echo '   *** FreeR disabled for warpNtrace ***'
endif
#
if ( $cycskip == $lctemp && $arpwarpmode != 'warp' && $lctemp != 0 ) then 
   set restr = 'RESTR'
endif
#
set lastlogfile = ${lastf} 
#
# Look for NCS
#
set ncsprot = ''
set ncswat = ''
#
if ( $ncs == 1 ) then
#
    if ( ! -e ../nonx.protein ) then
	echo '  nonx.protein was not found.'
	echo '   A file called nonx.protein, containing '
	echo '   a NONX card for protin is needed '
	echo '   e.g. NONX 5 CHNID A B C D E NSPANS 1 1 205 1'
	echo '   for refmac5 NONX NCHAINS 5 CHNID A B C D E NSPANS 1 1 205 1'
	exit
    endif
#
set ncsprot = `cat ../nonx.protein`
set nchains = `grep 'NONX' ../nonx.protein | awk -v add=${newrefmac} '{col=add+2;print $col}'`
set refchain = `grep 'NONX' ../nonx.protein | awk -v add=${newrefmac} '{col=add+4;print $col}'`
set startres = `grep 'NONX' ../nonx.protein | awk -v chains=$nchains -v add=${newrefmac} '{chains=chains+6+add;print $chains }'`
set endres = `grep 'NONX' ../nonx.protein | awk -v chains=$nchains -v add=${newrefmac} '{chains=chains+7+add;print $chains }'`
set refwatchain = ' M '
#
#
if ( ${last} == 0 ) then  
    echo '--------------------------------------------------------'
    echo 
    echo '  NCS for '$nchains' chains ,' $refchain' is reference, residues '$startres' to  '$endres
    echo '  Water master chain is '$refwatchain
    echo 
    echo '--------------------------------------------------------'
    echo 
endif
#
#
@ watflag = ${last}
#
if ( $watflag == 0 ) set watflag = `grep -c ' M ' arp_0.pdb`  
#
if ( $watflag != 0 ) then
#

if ( ${newrefmac} == 0 ) then
    echo  -n 'NONX '$nchains' CHNID ' > nonx.wat
else
    echo  -n 'NONX NCHAIN '$nchains' CHAIN ' > nonx.wat
endif
#
  set chaincount = 0
    while ( $chaincount != $nchains )
	if ( $chaincount < 3 ) @ nrchain = 115 + $chaincount
	if ( $chaincount > 2 ) @ nrchain = 117 + $chaincount
	if ( $chaincount == 11 ) @ nrchain = 130
	echo  -n ' \0'$nrchain' ' >> nonx.wat
	@ chaincount++
    end
    echo ' NSPANS 1 1 7000 1' >> nonx.wat 
    set ncswat = `cat nonx.wat`
else
    set ncswat = ''
endif
#
#
# Now, get rotations
#
cat > lsqop.${last} <<EOF
ROTATE EULER 0.0 0.0 0.0
TRANSLATE 0.0 0.0 0.0

EOF
#
#
if ( $last != 0 ) then 
    echo  -n '             Matching to reference chain, '$refchain', chain(s) ' 
else
    echo  -n '   Initial superposition to reference chain, '$refchain', of chain(s) ' 
endif

set chaincount = 1
#
while ( $chaincount != $nchains )
#
set workchain = `grep 'NONX' ../nonx.protein |head -1| awk -v workchain=$chaincount -v add=${newrefmac} '{workchain=workchain+add+4;print $workchain}'`
#
echo  -n $workchain'...'
#
set lastprog = LSQKAB
#
lsqkab \
workcd ${name}${last}.pdb \
refrcd ${name}${last}.pdb \
>lsqkab.log << eof
FIT WRES $startres to $endres WCHAIN $refchain
MATCH RRES $startres to $endres RCHAIN $workchain
OUTPUT RMS
END
eof
#
if ($status) goto exitlab
#
cat lsqkab.log >> ${lastf}
#
grep 'CROWTHER ALPHA BETA GAMMA ' lsqkab.log | awk '{printf"%s%10.3f%10.3f%10.3f\n", "ROTATE EULER ",$5,$6,$7}' >> lsqop.${last}
grep 'TRANSLATION VECTOR IN AS' lsqkab.log | awk '{printf"%s%10.3f%10.3f%10.3f\n",  "TRANSLATE ", $5,$6,$7}' >> lsqop.${last}
echo >> lsqop.${last}
#
# 
@ chaincount++
end
#
echo 'with rms of '`grep 'RMS     XYZ DISPLACEMENT' lsqkab.log | awk '{print $5}'`
#
endif 
#
###########################
#	NEW REFMAC BLOCK
#	NEW REFMAC BLOCK
#	NEW REFMAC BLOCK
###########################
#
if ( $arpwarpmode == 'warp' ) then
    echo ' ' > ${lastf}
endif
# Well, that needed for now, must be gone soon
#
#if ( $arpwarpmode != 'solvent' ) then
#    sed 's/ OW0 WAT/DUM  DUM/g'  ${name}${last}.pdb >t.pdb
#    cp t.pdb ${name}${last}.pdb
#endif
#
set lastprog = REFMAC5
#
@ cyccheck = $restrcyc - 2 * $restrref
set temptlsonoff = 0
#
if ( $tlsonoff == '1' ) then
    if ( $arpwarpmode == 'warpNtrace' ) then
	if ( $last > $cyccheck ) then
	    set temptlsonoff = 1
	else 
	    set temptlsonoff = 0
	endif
    endif
    if ( $arpwarpmode == 'molrep' || $arpwarpmode == 'solvent' ) then
	set temptlsonoff = 1
    endif
else
    set temptlsonoff = 0
endif
#    
@ flag = ($last - 1) % $restrref
#
if ( $temptlsonoff == '1' ) then
    set tlsincount = `wc ${tlsinfile} | awk '{print $1}'`
    if ( $tlsincount == '0' ) then
	set tlsin = ''
	set tlslab = ''
    else
	if ( $flag == 0 ) then
	    set tlsin = 'TLSIN '${tlsinfile}' TLSOUT temp.tls' 
	    set tlslab = 'REFI TLSC 5'
            echo '   TLS parameters will be Refined in this cycle.'
	else 
	    set tlsin = 'TLSIN '${tlsinfile}' ' 
	    set tlslab = ''
            echo '  TLS parameters will only be Used in this cycle.'
	endif

    endif
endif
#
#
refmac5 \
HKLIN ${datafile} XYZIN ${name}${last}.pdb XYZOUT ${name}${next}.pdb \
      HKLOUT ${name}${next}.mtz  ${extralib} ${tlsin} \
>>${lastf} << e
#
MAKE HYDR N
MAKE CHECK 0
LABIN FP=$fp SIGFP=$sigfp $freelabin $phaselabin
LABO FC=FC PHIC=PHIC   FWT=2FOFCWT PHWT=PH2FOFCWT -
     DELFWT=FOFCWT  PHDELWT=PHFOFCWT
REFI RESOLUTION ${resol} TYPE ${restr}
REFI RESI ${refmax} $phaseref
REFI BREF ISOTropic METH ${refmeth}
${tlslab}
WEIGHT ${weight} ${weightv}
DAMP ${damp} 
SCALE TYPE  ${scaleopt}
${scalml}
${bsolvent}
NCYC ${rrcyc}
MONI MANY
BLIMI 2 80
BINS 20
VDWR SIGMA DUMMY 50.0 INCREMENT DUMMY -1.0
VDWR 0.0
${ncsprot}
${ncswat}
END
e
#
if ($status) goto exitlab
#
#
if ( $tlsonoff == '1' && -e temp.tls ) /bin/cp temp.tls ${tlsinfile}
#
#
# If this is just after building or the first cycle print some ratios ...
# 
@ flag = ($last - 1) % $restrref
#
if (($flag == 0 && $arpwarpmode == 'warpNtrace' ) || $last == 0 ) then
	set xray = `grep 'Number of used reflections' ${lastf} | tail -1 | awk '{print $6}' `
	set compl = `grep 'Percentage observed ' ${lastf} | tail -1 | awk '{printf"%4.2f\n",$4}' `
#	set refatoms = ` wc ${name}${next}.pdb | awk '{print $1}' `
	set refatoms = ` grep "ATOM  " ${name}${next}.pdb | wc -l | awk '{print $1}' `
	set nrdist = `grep 'Bond distances: refined atoms' ${lastf} | tail -1 | awk '{print $5}' `
	set ratio = `echo $xray $refatoms | awk '{printf"%4.2f\n",(($1)/($2*4))}'`

	if ( $arpwarpmode == 'warp' || ( $last == 0 && $arpwarpmode == 'warpNtrace') || $restr == 'UNRESTR' ) then
	    echo '   '$xray 'reflections (' $compl' % complete ), for refining '$refatoms' atoms.'
	    echo '   Observations/parameters ratio is '$ratio
	    echo '------------------------------------------------------'
	else
	    echo '   '$xray 'reflections (' $compl' % complete ) and ' $nrdist' restraints for refining '$refatoms' atoms.'
	    echo '   Observations/parameters ratio is '$ratio
	    echo '------------------------------------------------------'
	endif

endif
#
# If it is the first cycle then print starting R !
if ( $last == 0 ) then
	set rfac = `grep "Overall R factor"  ${lastf} | head -1 |awk '{printf"%8.3f\n",$5}'`
	set freerfac = `grep "Free R factor"  ${lastf} | head -1 |awk '{printf"%8.3f\n",$5}'`
	set fom = `grep "Overall figure of merit "  ${lastf} | head -1 |awk '{printf"%8.3f\n",$6}'`
	set freefom = `grep "free_FOM"  ${lastf} | head -1 |awk '{printf"%8.3f\n",$2}'`
	set fofc = `grep "Overall correlation coefficient"  ${lastf} | head -1 |awk '{printf"%8.3f\n",$5}'`
	set freefofc = `grep "Free correlation coefficient"  ${lastf} | head -1 |awk '{printf"%8.3f\n",$5}'`
	if ($freerfac == '' ) set freerfac = '0.000'
	if ($freefofc == '' ) set freefofc = '0.000'
	if ($freefom == '' )  set freefom  = '0.000'

	set atcycle = `grep -c 'ATOM  '  ${name}${next}.pdb `

	echo  -n ' Starting model: ' 
	echo ' R = '$rfac '(Rfree = '$freerfac'). '
	echo '------------------------------------------------------'
#
	echo $last $rfac $freerfac $fom $freefom $fofc $freefofc 0 0 $atcycle 0 0 >>${tabf}
endif

# Print R factors after this run ...

	set rfac = `grep "Overall R factor"  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$5}'`
	set freerfac = `grep "Free R factor"  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$5}'`
	set fom = `grep "Overall figure of merit "  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$6}'`
	set freefom = `grep "free_FOM"  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$2}'`
	set fofc = `grep "Overall correlation coefficient"  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$5}'`
	set freefofc = `grep "Free correlation coefficient"  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$5}'`
	if ($freerfac == '' ) set freerfac = '0.000'
	if ($freefofc == '' ) set freefofc = '0.000'
	if ($freefom == '' ) set freefom = '0.000'
	echo  -n '  Cycle '$last':' 
	if ($last<100) then
           echo  -n ' '
        endif
	if ($last<10) then
           echo  -n ' '
        endif
#
	echo ' After refmac, R = '$rfac '(Rfree = '$freerfac').'
	set rmsdist = ` grep 'Bond distances: refined atoms' ${lastf} | tail -1 | awk '{print $6}' `
	set rmsang  = ` grep 'Bond angles  : refined atoms' ${lastf} | tail -1 | awk '{print $7}' `
	if ( $rmsdist == '' ) set rmsdist = 0
	if ( $rmsang == '' ) set rmsang = 0

#
set lastprog = FFT
#
#  Sigmaa style 2mfo-dfc map with restored data
#
fft hklin ${name}${next}.mtz mapout map_2mfoDfc.map \
>> ${lastf}  <<eof
TITLE Sigmaa style 2mfo-Dfc map calculated with refmac coefficients
LABIN F1=2FOFCWT PHI=PH2FOFCWT
RESOLUTION       ${resol}
end
eof
#
if ($status) goto exitlab
#
#   Sigmaa style mfo-dfc map
#
fft hklin ${name}${next}.mtz mapout map_mfoDfc.map \
>> ${lastf} <<eof
TITLE Sigmaa style mfo-Dfc map calculated with refmac coefficients
LABIN F1=FOFCWT PHI=PHFOFCWT
RESOLUTION       ${resol}
end 
eof
#
if ($status) goto exitlab
#
set lastprog = MAPMASK
#
mapmask MAPIN map_2mfoDfc.map MAPOUT ${name}${next}_2mfoDfc.ext \
>> ${lastf}  << e
XYZLIM ${xyzlim}
END
e
#
if ($status) goto exitlab
/bin/rm -f map_2mfoDfc.map
#
mapmask MAPIN map_mfoDfc.map MAPOUT ${name}${next}_mfoDfc.ext \
>> ${lastf}  << e
XYZLIM ${xyzlim}
END
e
#
if ($status) goto exitlab
/bin/rm -f map_mfoDfc.map
#
#
if ($status) goto exitlab
#
set arpsym = ${sym}
cp ${name}${next}.pdb arp_in.pdb
#
set lastprog = ARP_WARP_mode_shake
#
if ( $arpwarpmode != 'warpNtrace' && ( $rand1 == $next || $rand2 == $next || $rand3 == $next ) ) then
#
echo '------------------------------------------------------'
echo '  Will shake the model at this point ...'
#
mv arp_in.pdb to_be_shaked_${next}.pdb
#
set bup = $wilsonb
set bdown = `/bin/echo $wilsonb 2 | awk '{print $1/$2}'`
#
if ( $rand3 == $next ) then
    set rtimes = 'Third'
    set bcut = $bcut3
    set randshift = $randshift3
endif
#
if ( $rand2 == $next ) then
    set rtimes = 'Second'
    set bcut = $bcut2
    set randshift = $randshift2
endif
#
if ( $rand1 == $next ) then
    set rtimes = 'First'
    set bcut = $bcut1
    set randshift = $randshift1
endif
#
set wilsoncut = `/bin/echo $wilsonb $bcut | awk '{print $1*$2}'`
#	
set lastprog = ARP_WARP_MODE_SHAKE
#
$warpbin/arp_warp >>${lastf} <<EOF
MODE shakemodel light
FILES CCP4 XYZIN to_be_shaked_${next}.pdb XYZOUT after_shake_${next}.pdb
SYMM $sym
SHAKEMODEL BEXCL $wilsoncut BRESET $bup $bdown RANDOMISE ${randshift}
END
EOF
#
if ($status) goto exitlab
#
echo '  '$rtimes' randomisation, xyz shifts of '$randshift
#
echo '   B factor cutoff '$wilsoncut' and B factor reset between '$bdown' and '$bup
echo '------------------------------------------------------'
#
cp after_shake_${next}.pdb arp_in.pdb
#
endif
#
set lastprog = ARP_WARP_MODE_UPDATE
#
$warpbin/arp_warp >> ${lastf}  << e
$reset
MODE UPDATE ${arpmode}
FILES CCP4 XYZIN arp_in.pdb MAPREMOVE ${name}${next}_2mfoDfc.ext MAPFIND  ${name}${next}_mfoDfc.ext XYZOUT arp_out.pdb
SYMM       ${arpsym}
RESOLUTION ${resol}
REMOVE     ATOMS $rem CUTSIGMA ${rsig} MERGE ${mergedist} ${keepzero}
FIND       ATOMS $find CHAIN Z CUTSIGMA ${fsig} RESN ${freename}
${rsfitwater}
END
e
#
if ($status) goto exitlab
#
	set mergerem = `grep "total have been removed"  ${lastf}  | tail -1| awk '{print $1}' `
	set densrem = `grep "will be removed"  ${lastf} | tail -1| awk '{print $7}' `
	set found = `grep "New atoms found"  ${lastf}  | tail -1| awk '{print $2}' `
	@ allrem = $mergerem + $densrem
	echo  '             Found '$found' ('$find' requested) and removed ' $allrem' ('$rem' requested) atoms.'
#
	set atcycle = `grep -c 'ATOM  '  ${name}${next}.pdb `
#
#
# Time to write out info for the table !
#
echo $next $rfac $freerfac $fom $freefom $fofc $freefofc $found $allrem $atcycle $rmsdist $rmsang >>${tabf}
#
#
cat ${logf} ${lastf} > t
mv t ${logf}
#
# Here we handle the autobuilding
#  if correct cycle is reached.
# 
@ flag = $last % $restrref
@ bc = $last / $restrref
#
if ( $skip > $bc && $flag == 0 && $arpwarpmode == 'warpNtrace' ) then
    echo 
    echo '  Will skip this building ...'
    echo 
    set flag = 1
endif
#
# FREEBUILD IN REFMAC , DM ETC ETC
#
if ( $freebuild == 1 && $flag == 0 && $arpwarpmode == 'warpNtrace' && $skip == $bc ) then
#
#
echo 
echo '------------------------------------------------------'
#
#

    set freelog = ${WORKDIR}/${JOB_ID}_newfree_build.log
    if ( -e ${freelog}) then 
	/bin/rm -f ${freelog}
    endif
    touch ${freelog}


#
if ( $flatten == 0 ) then
#
# Just calculate latest refmac map for putting atoms in
#
set lastprog = FFT
#
echo 
echo ' Recalculating latest refmac map in fine grid.'
fft hklin ${name}${next}.mtz mapout arp_in.map \
>> ${freelog}  <<eof
TITLE Sigmaa style 2mfo-Dfc map calculated with refmac coefficients
LABIN F1=2FOFCWT PHI=PH2FOFCWT
RESOLUTION  20.0 1.2 
end
eof
#
if ($status) goto exitlab
#
else
#
# First flatten, then calculate map to put free atoms in ...
#
echo 

echo ' Solvent flattening now.' 
#
set lastprog = DM
#
dm hklin ${name}${next}.mtz hklout dm.mtz >>${freelog} <<eof
RESOLUTION $resol
SOLC ${solventc} 
MODE SOLV HIe
NCYCLE 20
LABIN FP=${fp} SIGFP=${sigfp} PHIO=PHIC FOMO=FOM
LABOUT PHIDM=PHIDM FOMDM=FOMDM
eof
#
if ($status) goto exitlab
#
set lastprog = FFT
#
echo ' Calculating solvent flattened  map in fine grid.'
fft hklin dm.mtz mapout arp_in.map \
>> ${freelog}  <<eof
TITLE Sigmaa style 2mfo-Dfc map calculated with refmac coefficients
LABIN F1=${fp} PHI=PHIDM W=FOMDM
RESOLUTION  20.0 1.2
end
eof
#
if ($status) goto exitlab
#
endif
#
mapmask mapin arp_in.map mapout arp_in.ext >> ${freelog} <<EOF
XYZLIM ${xyzlim}
EOF
#
if ($status) goto exitlab
#
set protsmall = `echo $protsize | awk '{printf"%7d",$1/2}' `
#
set lastprog = ARP_WARP_MODE_MIRBUILD
#
echo ' Building free atoms model in new map.'
$warpbin/arp_warp >> ${freelog} <<EOF
MODE MIRBUILD
MIRBUILD ATOMS ${protsize} MODELS 1 RESN ${freename}
FILES CCP4 MAPFIND arp_in.ext XYZOUT1 arp_out.pdb 
SYMM ${sym}
CELL ${cell}
RESOLUTION ${resol}
END
EOF
#
if ($status) goto exitlab
#
#
# Printout if there is a cell difference
set celldiff = `grep "Cells differ:" ${freelog} | wc -l | awk '{print $1}' `
if ( $celldiff != "0" ) then
echo $boldon
grep "Cells differ:" ${logf}
echo 
echo ' If you are using a muti-dataset MTZ file, there might be a confusion'
echo ' between the MASTER cell and other cells. The job will continue.'
echo ' However, please consider re-building the MTZ so that it contains one'
echo ' dataset only, and then re-submitting ARP/wARP.'
echo 
echo $boldoff
endif
#
set lsig = `grep 'sigmas )' ${freelog} | tail -1 | awk '{print $5}'`
echo ' Had to go as low as '$lsig' sigma, to complete atoms search.'
echo ' Free atoms will be refined for one more big cycle.'
echo 
set flag = 1
#
echo '------------------------------------------------------'
echo 
#
endif
#
# Randomisation instead of building ???
#
if ( $flag == 0 && $arpwarpmode == 'warpNtrace' && (( $rand1 == $bc && $randtimes >= 1 ) || ( $rand2 == $bc && $randtimes >= 2 ) || ( $rand3 == $bc  && $randtimes == 3 ) )) then
#
echo '------------------------------------------------------'
echo '  Will skip this building and will shake the model instead ...'
#
mv arp_out.pdb to_be_shaked_${bc}.pdb
#
set bup = $wilsonb
set bdown = `echo $wilsonb 2 | awk '{print $1/$2}'`
#
if ( $rand3 == $bc ) then
    set rtimes = 'Third'
    set bcut = $bcut3
    set randshift = $randshift3
endif
if ( $rand2 == $bc ) then
    set rtimes = 'Second'
    set bcut = $bcut2
    set randshift = $randshift2
endif
if ( $rand1 == $bc ) then
    set rtimes = 'First'
    set bcut = $bcut1
    set randshift = $randshift1
endif
#
#
set wilsoncut = `echo $wilsonb $bcut | awk '{print $1*$2}'`
#	
set lastprog = ARP_WARP_MODE_SHAKE
#
$warpbin/arp_warp >>${lastf} <<EOF
MODE shakemodel light
FILES CCP4 XYZIN to_be_shaked_${bc}.pdb XYZOUT after_shake_${bc}.pdb
SYMM ${sym}
SHAKEMODEL BEXCL $wilsoncut BRESET $bup $bdown RANDOMISE ${randshift}
END
EOF
#
if ($status) goto exitlab
#
echo '  '$rtimes' randomisation, xyz shifts of '$randshift
echo '   B factor cutoff '$wilsoncut' and B factor reset between '$bdown' and '$bup
echo '------------------------------------------------------'
#
cp after_shake_${bc}.pdb arp_out.pdb
#
set flag = 1
#
endif
#
#
#
#
# START OF BUILDING 
# START OF BUILDING 
# START OF BUILDING 
#
if ($flag == 0 && $arpwarpmode == 'warpNtrace' ) then
#
# Getting atomic shape factor (two_omega)
set nres = `echo $protsize | awk '{print int($1/8)}'`
#
set lastprog = ARP_MODE_WILSON
#
${warpbin}/arp_warp > ${logomega} << e
MODE WILSON NRES ${nres}
FILES CCP4 HKLIN ${name}${next}.mtz
RESOLUTION ${resol}
LABELS     FP=$fp SIGFP=$sigfp FUSE=2FOFCWT
END
e
#
if ($status) goto exitlab
#
set twoomega       = `grep "Two_omuse"  ${logomega} | awk '{printf"%6.2f\n",$8}'`
set twoomegares    = `echo $twoomega | awk '{printf"%6.2f\n",(($1/2-0.32)/0.17)}'`
set twoomegarespar = `echo $twoomegares' '$solventc | awk '{printf"%6.2f\n",($1*((1/$2-1)^0.333))}'`
#
echo '------------------------------------------------------'
echo ' Building Cycle '$bc'    Atomic shape factors  '$twoomegares'  '$twoomegarespar
#
set ccc = 1 
#
if ( $newrefmac == '0' ) then
    sed 's/ OW0 WAT/DUM  DUM/g' arp_out.pdb > trace_${ccc}.pdb
else
    cp arp_out.pdb trace_${ccc}.pdb
endif
#
@ multic = $multit + 1
#
#echo 'Trace CYCLES' $multit $multic
#
set score = "1"
#
while ($ccc != $multic )   
#
if ( $ccc == $multit ) then
  set adddummy = 'noadd_dummy'
else
  set adddummy = 'add_dummy'
endif
#echo '   Round '$ccc': '$adddummy 
#
@ cnext = $ccc + 1
#
if ( $whichtrace == 0 ) then
#
set lastprog = MAIN_TRACE
set lastlogfile = ${lastfb} 
#
$warpbin/main_trace mapin1 ${name}${next}_2mfoDfc.ext xyzin trace_${ccc}.pdb xyzout trace_${cnext}.pdb \
> ${lastfb} << e
${sym} 
1
end
e
#
if ($status) goto exitlab
#
endif
#
#
if ( $whichtrace == 1 ) then
#
set lastlogfile = ${lastfb} 
#
# Not sure what this is for but removal of atoms with zero crds is fatal
#grep -v '   0.000 ' trace_${ccc}.pdb >ttt.pdb
sed 's/   0.000 /   0.001 /g' trace_${ccc}.pdb >ttt.pdb
mv ttt.pdb trace_${ccc}.pdb
#
#
set lastprog = CUBES 
#
$warpbin/cubes \
  xyzin trace_${ccc}.pdb \
  xyzref trace_${ccc}.pdb \
  mapin ${name}${next}_2mfoDfc.ext \
  DENSDAT $warpbin/cubes_dens.dat \
  TABLEDAT $warpbin/cubes_table.dat > ${lastfb} << e 
RUN
${sym}
$resol
e
#
if ($status) goto exitlab
#
set lastprog = PEPT_HMAIN
#
$warpbin/pept_hmain \
   mapin1 ${name}${next}_2mfoDfc.ext \
   xyzin trace_${ccc}.pdb \
   xyzout trace_${cnext}.pdb \
    >> ${lastfb} << e
${sym} 
${adddummy}
end
e
#
if ($status) goto exitlab
#
endif
#
# Retrieving the previous score
set scoreold = $score
#
# Getting the number of peptides and chains
set pepts = `grep 'onnectivity' ${lastfb} | tail -1 | awk '{print $6}'`
set tch = `grep 'onnectivity' ${lastfb} | tail -1 | awk '{print $2}'`
#
# Getting the current score and its change
set score1 = `echo $pepts' '$tch | awk '{print $1-2.0*$2}'`
set tscore = `grep 'Tracing score' ${lastfb} | tail -1 | awk '{print $3}'`
set score  = `echo $score1 $tscore | awk '{print ($1+$2*2)/3}'`
set scorechange = ` echo $score' '$scoreold | awk '{print $1/$2}'`
#
if ( $multit != 1 ) then
#
# Decision making:
# If score improved by more than 5 % - interate the cycle
# If score improved by less than 5 % - leave the loop
# If score became worse - take the previous result
  set evaluatescore = `echo $scorechange | awk '{if ($1>1.05) print "iterate"} {if ($1<=1.05) print "leave" }'` 
  if ( $evaluatescore == "leave" ) then
    set evaluatescore = `echo $scorechange | awk '{if ($1>=1.00) print "leave"} {if ($1<1.00) print "previous"}'` 
  endif
#
set longestchain = `grep 'Chain #  1' ${lastfb} | tail -1 | awk '{print $7}'`
if ( $longestchain == '' ) set longestchain = "0"
# Printout
  echo '   Round '$ccc': '$pepts' peptides in '$tch' chains. The longest chain comprises '$longestchain' peptides.'
#
  if ( $evaluatescore == "leave" || $evaluatescore == "previous" ) then
    @ bestround = $ccc
    if ( $evaluatescore == "previous" ) then
      cp trace_${ccc}.pdb trace_${cnext}.pdb
      @ bestround = $ccc - 1
    endif
#
    grep -v "DU1  DUM" trace_${cnext}.pdb > trace_${cnext}_1.pdb
    grep -v "DU0  DUM" trace_${cnext}_1.pdb > trace_${cnext}_2.pdb
    mv trace_${cnext}_2.pdb trace_${cnext}.pdb
    /bin/rm -f trace_${cnext}_1.pdb
    /bin/rm -f trace_${ccc}.pdb
    goto skipnext
  endif
#
endif
#
/bin/rm -f trace_${ccc}.pdb
@ bestround = $ccc
#
@ ccc++ 
end
#
skipnext:
mv trace_${cnext}.pdb ${name}pept_${bc}.pdb
#
if ( $bestround == "0" ) @ bestround = 1
echo '   Taking the results from Round '$bestround
#
if ( $side <= $bc && $side != -1 ) then
#
set lastprog =  SNOW 
#
# Break for OSF1 Version 4
#
set alphaos  = `uname`
set alphaver = `uname -r`
if ( $alphaos == 'OSF1' ) then
  if ( $alphaver != 'V5.0' && $alphaver != 'V5.1' ) then
     echo $boldon
     echo 
     echo ' Sorry, the executable for the SNOW module is not available for this platform'
     echo ' Consider remote submission or running the job on another operating system'
     echo $boldoff
     goto exitlab
  endif
endif
#
set qcell = `/bin/echo "'"${cell}"'"`
#
  if ( $last < $restrcyc - $restrref ) then
    set shuffle = 0
    set junkdum = 0
  else
    set shuffle = 1
#    set junkdum = 1
    set junkdum = 0
    echo 
    echo '  Last building cycle: '
    echo '  Chain fragments will be rearranged'
  endif
#
$warpbin/snow -paramfile=- >> ${lastfb} <<EOF
IncludeChains = 
MessageFilename = snow_msg.txt
AbortLevel = 8
MessageLevel = 3
ProgramName = snow
DictionaryFilename = $warpbin/AAbis.XYZ
MinContactDist = 0.9
MaxContactDist = 1.7
DeleteUsedDummies = 0
MinCScore = 2
UniformAtomRadius = 0.74
AntiBumpFactor = 2.0
SymmetryFilename = $warpbin/symop.sym
UniformAtomBFactor = $wilsonb
SpaceGroup = $sym 
cell = $qcell 
PDBInputFilename = ${name}pept_${bc}.pdb
PDBOutputFilename =  ${name}snow_${bc}.pdb
NumberOfSequence = 1
SequenceFilename = $seqin
SequenceMultiplicty = ${cgr} 
MapFilename = ${name}${next}_2mfoDfc.ext 
ConformationGainThreshold = 1.0
PerformSequenceDocking = 1 
PerformSideChainFitting = 1
PerformSideChainRefinement = 1 
PerformDummiesRejection = 0
PerformReshuffling = $shuffle 
RemoveAllDummies = $junkdum 
EOF
#
if ($status) goto exitlab
#
#
# Unused Snow keywords
#OutputTopologiesTo = ./final_topo_out.txt
#OutputClassAsVector = no
#TopologiesOutputToFilename = ./topo_out.txt
#OutputSecondConformationTo = ${name}snow_2ndConf_${bc}.pdb
#OutputFitResidualTo = ${name}snow_fit_${bc}.map
#OutputRefineResidualTo = ${name}snow_refi_${bc}.map
#DummyRejectionThreshold = -200.0
#
set cindex = `grep 'onnectivity' ${lastfb} | tail -1 | awk '{print $12}'`
set cchains = `grep 'Number of fragments' ${lastfb} | tail -1 | awk '{print $5}'` 
set cres = `grep 'Number of residues' ${lastfb} | tail -1 | awk '{print $5}'` 
set dcchains = `grep 'Number of docked fragments' ${lastfb} | tail -1 | awk '{print $6}'` 
set dcres = `grep 'Number of docked residues' ${lastfb} | tail -1 | awk '{print $6}'` 
#
if ( $cres == '' ) then
  set cres    = "0"
  set cchains = "0"
endif
if ( $dcres == '' ) then
  set dcres    = "0"
  set dcchains = "0"
endif
#
echo $boldon
echo '  Chains '$cchains', Residues '$cres', Connectivity Index '$cindex
echo '  '$dcchains' of these ('$dcres' residues) have been docked in sequence.'
echo $boldoff
#set err = ` sort.csh  /home/ztony/xyls4.mtz  ${name}${next}.mtz  PHIC  |  awk '{print $1}'`
#echo "$cindex  $cchains  $cres	 $dcchains  $dcres	 $freerfac  $rfac  $twoomegares  $twoomegarespar  $err" >> /#home/ztony/oasis_arp.log






#
echo $next $cchains $cres $cindex $dcchains $dcres >> ${tabfb}
#
# Check for no-solution while reshuffling fragments within Snow
if ( $shuffle == "1" ) then 
  echo $boldon
  grep "WARNING : VERY likely the sequence docking" ${lastfb}
  echo $boldoff
endif
#
echo '------------------------------------------------------'
#
cp ${name}snow_${bc}.pdb arp_out.pdb
#
#
#
#
  if ( $last >= $restrcyc - $restrref ) then
    if ( $dcres == '' ) then
      set dcres = "0"
    endif
    set seqcover = `echo $dcres $cres | awk '{printf"%3d",100*$1/($2+1)}'` 
    echo $boldon
    echo ' Sequence coverage is '$seqcover' %'
    echo $boldoff
    set seqcovermode = `echo $seqcover | awk '{if ($1>80) print "wat"} {if ($1<=80) print "dum" }'` 

    if ( $seqcovermode == "wat" ) then
      echo '  All DUM atoms will be removed'
      grep -v "DUM  DUM" arp_out.pdb > arp_out1.pdb
      mv arp_out1.pdb arp_out.pdb
    else
      echo $boldon
      echo ' Consider running further cycles of model building using '${JOB_ID}_$prefix'.pdb as input'
      echo $boldoff
    endif
  endif
#
#pdbset xyzin ${name}snow_${bc}.pdb xyzout t_out.pdb >> ${lastfb} <<e
#CELL $cell
#END
#e
#
#sed 's/  DUM DUM/ DUM  DUM/g' t_out.pdb > arp_out.pdb
#
else
#
set lastprog = RESHUFFLE
#
# Here we remove the tls file if it exists - we are recreating it anyway
#
if ( -e ${tlsinfile} ) then
    /bin/rm -f ${tlsinfile}
endif
#
$warpbin/reshuffle xyzin ${name}pept_${bc}.pdb \
xyzout ${name}resuf_${bc}.pdb TLSOUT ${tlsinfile} >> ${lastfb} <<e
MOLECU ${cgr}
GRID 3
XYZLIM $xyzlim
SYMM  $sym
END
e
#
if ($status) goto exitlab
#
set cindex = `grep 'onnectivity' ${lastfb} | tail -1 | awk '{print $12}'`
set cchains = `grep 'Molecule  ' ${lastfb} | tail -$cgr | awk '{tot += $3 } END {print tot}'`
set cres = `grep 'Molecule  ' ${lastfb} | tail -$cgr |  awk '{tot += $5 } END {print tot}'`
#
echo $boldon
echo '  Chains '$cchains', Residues '$cres', Connectivity Index '$cindex
echo $boldoff
#
cp ${name}resuf_${bc}.pdb arp_out.pdb
#
    set seqcovermode = "dum"
#
endif
#
#
#
set lastprog = ARP_WARP_MODE_UPDATE_BUILD
#
# Removing DUMs only on the basis of merging
$warpbin/arp_warp >> ${lastfb} <<EOF
MODE UPDATE allatoms
FILES CCP4 XYZIN arp_out.pdb MAPREMOVE ${name}${next}_2mfoDfc.ext MAPFIND ${name}${next}_mfoDfc.ext XYZOUT arp_out_1.pdb 
SYMM       ${sym}
RESOLUTION ${resol}
REMOVE     ATOMS 9999 CUTSIGMA -9.9 MERGE 0.7 ${keepzero}
FIND       ATOMS 1 CHAIN Z CUTSIGMA 9.9 RESN ${freename}
END
EOF
#
if ($status) goto exitlab
#
#
#
# Estimating the number of DUM atoms still to be removed
set curratomspept = `grep "ATOM  " ${name}pept_${bc}.pdb | wc -l | awk '{print $1}'` 
set curratomssnow = `grep "ATOM  " arp_out.pdb | wc -l | awk '{print $1}'` 
set curratomsarp  = `grep "ATOM  " arp_out_1.pdb | wc -l | awk '{print $1}'` 
set maxremove1    = `echo ${curratomsarp}' '${goal} | awk '{printf"%5d",$1-$2*0.9}'`
set maxremove     = `echo $maxremove1 | awk '{if ($1>0) print $1} {if ($1<=0) print "1" }'` 
#echo ' atoms in the pept file '${curratomspept}
#echo ' atoms in the snow file '${curratomssnow}
#echo ' atoms in the arp  file '${curratomsarp}
#echo ' atoms still to remove '${maxremove1}
#
#
#
set lastprog = ARP_WARP_MODE_UPDATE_BUILD
#
# Removing DUMs only on the basis of density
$warpbin/arp_warp >> ${lastfb} <<EOF
MODE UPDATE waters
FILES CCP4 XYZIN arp_out_1.pdb MAPREMOVE ${name}${next}_2mfoDfc.ext MAPFIND ${name}${next}_mfoDfc.ext XYZOUT arp_out_2.pdb 
SYMM       ${sym}
RESOLUTION ${resol}
REMOVE     ATOMS ${maxremove} CUTSIGMA ${rrsig} MERGE 0.7  ${keepzero}
FIND       ATOMS 1 CHAIN Z CUTSIGMA 9.9 RESN ${freename}
END
EOF
#
if ($status) goto exitlab
#
#
#
/bin/rm -f arp_out_1.pdb
mv arp_out_2.pdb arp_out.pdb
#
cat ${logfb} ${lastfb} >t
mv t ${logfb}
#
#
endif
#
# END OF BUILDING 
#
# Now, in case this is the VERY LAST cycle we should
# calculate a map which covers the newly build molecule.
#
if (-e ../STOP.EXE) then
    echo ' Cycling interrupted by user.'
    /bin/rm -f ../STOP.EXE
     @ next = $restrcyc
endif
#
if (-e ../ABANDON.EXE) then
    echo ' Program stopped by user.'
    /bin/rm -f ../ABANDON.EXE
    exit
endif
#
if ( $next == $restrcyc) then
#
echo 
echo '   Writing map files covering molecule ...'
#
set lastprog = MAPMASK
#
mapmask MAPIN ${name}${next}_2mfoDfc.ext MAPOUT ${filesloc}map_2mfoDfc_${prefix}.ext \
XYZIN arp_out.pdb >>${logf}  << e
BORDER 5
END
e
#
if ($status) goto exitlab
#
cp ${name}${next}_2mfoDfc.ext ${filesloc}map_2mfoDfc_${prefix}.map 
#
mapmask MAPIN ${name}${next}_mfoDfc.ext MAPOUT ${filesloc}map_mfoDfc_${prefix}.ext \
XYZIN arp_out.pdb >>${logf}  << e
BORDER 5
END
e
#
if ($status) goto exitlab
#
cp ${name}${next}.mtz ${filesloc}${prefix}.mtz    
#       
endif
#
#

/bin/rm -f ${name}${next}.pdb
cp arp_out.pdb ${name}${next}.pdb



@ mflag = $last % $restrref
if ( $mflag == 0 ) then
#



set seqcover = `echo $dcres $cres | awk '{printf"%3d",100*$1/($2+1)}'` 
set seqcovermode = `echo $seqcover | awk '{if ($1>80) print "wat"} {if ($1<=80) print "dum" }'` 

if ( $seqcovermode == "wat" ) then
   grep -v "DUM  DUM" arp_out.pdb > arp_out1.pdb
else
   rm -f  arp_out1.pdb
   cp arp_out.pdb arp_out1.pdb
endif

    if ( $seqcovermode == "wat" ) then
      set rsfitwater1 = `echo $rh | awk '{if ($1>2.2) print " " ; else print "REFINE WATERS"}'`
      set mergedist1 = '2.2'
      set rsig1 = '1.0'
      set fsig1 = $fsig
      set rem1 = $find
      set freename1 = 'WAT'
    else
      set rsig1 = -50.0
      set fsig1 = 50.0
      set rem1 = $rem
      set rsfitwater1 = $rsfitwater
      set freename1 = $freename
      set mergedist1 = $mergedist
    endif




$warpbin/arp_warp > tmp.log << e
MODE UPDATE waters
FILES CCP4 XYZIN arp_out1.pdb MAPREMOVE ${name}${next}_2mfoDfc.ext MAPFIND ${name}${next}_mfoDfc.ext XYZOUT arp_out2.pdb
SYMM       ${sym}
RESOLUTION ${resol}
REMOVE     ATOMS $rem1 CUTSIGMA ${rsig1} MERGE ${mergedist1}
FIND       ATOMS $find CHAIN Z CUTSIGMA ${fsig1} RESN ${freename1}
${rsfitwater1}
END
e


rm -fr arp_out1.pdb
mv arp_out2.pdb arp_out1.pdb

#echo $dcres $cres $rfac $last
set ifsig = `echo $dcres" "$dcreslast | awk '{ if ( $1 >= $2) {print "true";}else{print "false" ;}  }'`
if ( $ifsig == "true") then
set dcreslast = $dcres
set di = $bc
set dc = $cres
set dr = $rfac
if ( $rfree_signal == 1  ) then
set drfree = $freerfac
endif
if ( -e arp_last.pdb ) rm -f arp_last_dres.pdb
cp arp_out1.pdb arp_last_dres.pdb
if ( -e arp_last.mtz ) rm -f arp_last_dres.mtz
cp ${name}${next}.mtz   arp_last_dres.mtz
endif




set ifsig = `echo $cres" "$creslast | awk '{ if ( $1 >= $2) {print "true";}else{print "false" ;}  }'`
if ( $ifsig == "true") then
set creslast = $cres
set cri = $bc
set crd = $dcres
set crr = $rfac
if ( $rfree_signal == 1  ) then
set crfree = $freerfac
endif
if ( -e arp_last.pdb ) rm -f arp_last_cres.pdb
cp arp_out1.pdb arp_last_cres.pdb
if ( -e arp_last.mtz ) rm -f arp_last_cres.mtz
cp ${name}${next}.mtz   arp_last_cres.mtz
endif


set ifsig = `echo $rfac" "$rlast | awk '{ if ( $1 <= $2) {print "true";}else{print "false" ;}  }'`
if ( $ifsig == "true") then
set rlast = $rfac
set ri = $bc
set rc = $cres
set rd = $dcres
if ( $rfree_signal == 1  ) then
set rrfree = $freerfac
endif
if ( -e arp_last.pdb ) rm -f arp_last_r.pdb
cp arp_out1.pdb arp_last_r.pdb
if ( -e arp_last.mtz ) rm -f arp_last_r.mtz
cp ${name}${next}.mtz   arp_last_r.mtz
endif


if ( $rfree_signal == 1 ) then
set ifsig = `echo $freerfac" "$rfree_rfree | awk '{ if ( $1 <= $2) {print "true";}else{print "false" ;}  }'`
if ( $ifsig == "true") then
set rfreelast = $rfac
set rfreei = $bc
set rfreec = $cres
set rfreed = $dcres
set rfree_rfree = $freerfac
if ( -e arp_last.pdb ) rm -f arp_last_rfree.pdb
cp arp_out1.pdb arp_last_rfree.pdb
if ( -e arp_last.mtz ) rm -f arp_last_rfree.mtz
cp ${name}${next}.mtz   arp_last_rfree.mtz
endif
endif

rm -f arp_out1.pdb
endif

/bin/rm -f ${name}${next}_2mfoDfc.ext
/bin/rm -f ${name}${next}_mfoDfc.ext
/bin/rm -f ${name}${next}.mtz
#
#
@ last++
@ count++
end
#

echo '$$' >>${tabf}
/bin/rm -f ${lastf}
if ( $arpwarpmode == 'warpNtrace' ) then
    /bin/rm -f ${lastfb}
    echo '$$' >>${tabfb}
endif
#
#
#
echo $boldon
echo ' Normal termination of '$prefix 
echo $boldoff
#
# Go up from working directory
# Either $prefix for non-interface
# ... or $arpwarpdir for ccp4ish
#
cd ..
#
#
#
#
echo "set rfree_signal = $rfree_signal" > ${main_path}/${name_c}_result.par

    cp ${arpwarpdir}/${name}${next}.pdb ${filesloc}$prefix.pdb
    cp ${filesloc}$prefix.pdb   ${main_path}/${name_c}_arp.pdb
    cp ${filesloc}${prefix}.mtz  ${main_path}/${name_c}_arp.mtz
    cp ${arpwarpdir}/arp_last_dres.pdb ${main_path}/${name_c}_arp_dres.pdb
    cp ${arpwarpdir}/arp_last_dres.mtz ${main_path}/${name_c}_arp_dres.mtz
    cp ${arpwarpdir}/arp_last_cres.pdb ${main_path}/${name_c}_arp_cres.pdb
    cp ${arpwarpdir}/arp_last_cres.mtz ${main_path}/${name_c}_arp_cres.mtz
    cp ${arpwarpdir}/arp_last_r.pdb ${main_path}/${name_c}_arp_r.pdb
    cp ${arpwarpdir}/arp_last_r.mtz ${main_path}/${name_c}_arp_r.mtz
    if ( $rfree_signal == 1 ) then
      echo "set recommend = ( $dcres $cres $rfac $freerfac )" >> ${main_path}/${name_c}_result.par
      echo "set dock_best = ( $dcreslast $dc $dr $di $drfree )" >> ${main_path}/${name_c}_result.par
      echo "set res_best = ( $crd $creslast $crr $cri $crfree)" >> ${main_path}/${name_c}_result.par
      echo "set r_best = ( $rd $rc $rlast $ri $rrfree)" >> ${main_path}/${name_c}_result.par
      echo "set rfree_best = ( $rfreed $rfreec $rfreelast $rfreei $rfree_rfree)" >> ${main_path}/${name_c}_result.par
      cp ${arpwarpdir}/arp_last_rfree.pdb ${main_path}/${name_c}_arp_rfree.pdb
      cp ${arpwarpdir}/arp_last_rfree.mtz ${main_path}/${name_c}_arp_rfree.mtz
    else
      echo "set recommend = ( $dcres $cres $rfac 0 )" >> ${main_path}/${name_c}_result.par
      echo "set dock_best = ( $dcreslast $dc $dr $di 0 )" >> ${main_path}/${name_c}_result.par
      echo "set res_best = ( $crd $creslast $crr $cri 0 )" >> ${main_path}/${name_c}_result.par
      echo "set r_best = ( $rd $rc $rlast $ri 0 )" >> ${main_path}/${name_c}_result.par
    endif
    /bin/rm -f -r ${arpwarpdir}

  endif

#
#
exit
exitlab:
#cd ..
#
# Printout if there is a cell difference
if ( ${lastprog} == "ARP_WARP_MODE_MIRBUILD" ) then
  set celldiff = `grep "Cells differ:" ${freelog} | wc -l | awk '{print $1}' `
  if ( $celldiff != "0" ) then
    echo $boldon
    echo 
    grep "Cells differ:" ${logf}
    echo 
    echo ' If you are using a muti-dataset MTZ file, there might be a confusion'
    echo ' between the MASTER cell and other cells. The job must exit now.'
    echo ' Please consider re-building the MTZ so that it contains one'
    echo ' dataset only, and then re-submitting ARP/wARP.'
    echo 
    echo $boldoff
  endif
endif


echo $boldon
echo 'QUITING ... PROGRAM TO BLAME: '${lastprog}
echo 'QUITING ... PROGRAM TO BLAME: '${lastprog}
echo 'QUITING ... PROGRAM TO BLAME: '${lastprog}
echo 
echo '*** Look for error message at file: '${lastlogfile}
echo '*** Look for error message at file: '${lastlogfile}
echo '*** Look for error message at file: '${lastlogfile}
echo 
echo $boldoff


