#!/bin/csh -f

source $1
set scaleopt = " $scale LSSC ANIS "
set restrcyc = 50
set restrref = 5
set wmat = AUTO
set weightv =  
set models = 1
set solvent = 1
set flatten = 0
set freebuild = 0
set scanis = Y 
set refmax = MLKF 
set freer = $EXCLUDE_FREER 
set freerml = $EXCLUDE_FREER
set cycskip = 0 
set skip = 0 
set flagk = 1 
set truncshifts = 1 
set multit = 5 
set upmore = 1 
set side = 0 
set fsig = 3.2 
set flagf = 0 
set randtimes = 0 
set rand1 = 0 
set randshift1 = 0.5 
set bcut1 = 2.0 
set rand2 = 20
set randshift2 = 0.5 
set bcut2 = 2.0 
set rand3 = 30 
set randshift3 = 0.5 
set bcut3 = 2.0 
set keepdata = WORLD 
set remote = 0 
set remoteemail =   
set damp = " 0.99  0.99 "
set rsig = 1.0 
setenv boldon "tput bold"
setenv boldoff "tput rmso"
set filesloc = `pwd`/files/
@ dcreslast = 0
@ creslast = 0
@ rlast = 10
@ rfree_rfree = 10
#
if ( $ncs_num > 1 ) then
set protsize = `echo $seq_num $ncs_num | awk '{print $1*$2*8;}'`
else
set protsize = `echo $seq_num | awk '{print $1*8;}'`
endif

#echo "##################################################" >> /home/ztony/oasis_arp.log
#echo "$JOB_ID" >> /home/ztony/oasis_arp.log
#echo "##################################################" >> /home/ztony/oasis_arp.log

if ( $modeccp4i == WARPNTRACEMODEL ) then
  set REF_MODE = REFML
endif

rm -fr ${WORKDIR}/oasis_arp.mtz
cp $datafile ${WORKDIR}/oasis_arp.mtz
set datafile = "${WORKDIR}/oasis_arp.mtz"
if ( $EXCLUDE_FREER == "Y" ||  $arp_select_mode == "rfree" || $select_mode == "rfree" ) then
	set freelabin = " FREE=$RFREE "
	set scalml = ' SCAL MLSC FREE '
	set rfree_signal = 1
else
	set rfree_signal = 0
	set freelabin = '  '
	set scalml = ' SCAL MLSC '
endif
###
if ( $REF_MODE == "REFML" ) then
	set phaselabin = '   '
	set phaseref = '   '
else
	set phaselabin = ' PHIB=$phibest FOM=$fom  '
	set phaseref = '  PHAS SCBL 1.0 '
endif

if ( $hl_signal == 1 ) then
        set phaselabin = " HLA=$HLA HLB=$HLB HLC=$HLC HLD=$HLD  "
endif


mtzdump hklin ${datafile} > ${WORKDIR}/mtz_dump.log <<EOF
NREF 0
GO
EOF

set resol = `awk '/Resolution Range/,/Sort Order/' ${WORKDIR}/mtz_dump.log | awk '(NF==8) { if ($4 < 20.0) print $4,$6 ; else print '20.0', $6 }'`
set res = `awk '/Resolution Range/,/Sort Order/' ${WORKDIR}/mtz_dump.log | awk '(NF==8) { print $4,$6}'`
set rsig = ` echo $res' '$rsig | awk '{ if ( $2 > 2.80 ) print "0.6";else print $3}' `
#



if ( $whichtrace == 1 ) then
  set rrcyc = ` echo $res | awk '{ if ( $2 > 2.30 ) print "3"; else print "1"}' `
  set albe = `echo $res | awk ' {if ( $2 >= 2.7 ) print "1";else print "0"} ' `
else
  set rrcyc = 1
  set albe = 0
endi


$warpbin/arp_warp > ${WORKDIR}/arp_aulim_extract.log <<EOF
MODE MIRBUILD
SYMM $sym
END
EOF
#
set xlim = `grep 'Asymmetric unit limits' ${WORKDIR}/arp_aulim_extract.log |awk '{printf"%.4f", $4/$6+0.000049}' | sed 's/\,/\./' `
set ylim = `grep 'Asymmetric unit limits' ${WORKDIR}/arp_aulim_extract.log |awk '{printf"%.4f", $7/$9+0.000049}' | sed 's/\,/\./'`
set zlim = `grep 'Asymmetric unit limits' ${WORKDIR}/arp_aulim_extract.log |awk '{printf"%.4f", $10/$12+0.000049 }' | sed 's/\,/\./'`
#

set xyzlim = "  0.0 $xlim 0.0 $ylim 0.0 $zlim  "

set fuse = $fp

#echo $xyzlim

#echo $resol $res $damp $rrcyc $rsig $fp
##########################################################################################################################################


# This should be controlled by the auto_tracing.sh file
if ( $whichtrace == '1' ) then
  set lenfragexclude = '2'
else
  set lenfragexclude = '4'
endif
#
if ( $modeccp4i == 'WARPNTRACEPHASES' || $modeccp4i == 'WARPNTRACEMODEL' ) then
  set arpwarpmode = 'warpNtrace'
else
  set arpwarpmode = 'atomupdate'
endif
#


$warpbin/arp_warp > ${WORKDIR}/arp_wilson.log <<EOF
MODE WILSON NRES $SEQ_NUM
FILES CCP4 HKLIN $datafile
RESOLUTION $resol
LABELS FP=${fp} SIGFP=${sigfp} FUSE=${fuse}
END
EOF
#

set wilsonb = `grep 'Bfactor' ${WORKDIR}/arp_wilson.log | awk '{printf "%.1f",$4+0.00999} '`
set solventc = `grep 'Solvent content' ${WORKDIR}/arp_wilson.log | awk '{printf "%.2f",$3+0.000999} '`
echo $wilsonb $solventc

#########################################
#########################################
ccp4istart:
#########################################
######################################### 
#
set lastprog = MAIN_SCRIPT
set boldon  = '<B><FONT COLOR="#FF0000"><\!--SUMMARY_BEGIN-->'
set boldoff = '<\!--SUMMARY_END--></FONT></B>'
#
# Sourcing the parameter file
echo 'The parameter file is:' $1
echo 
#
#
# RUN_Locally
#
if ( $remote ) then
  echo 'The ARP/wARP job will run remotely on the EMBL Hamburg cluster'
else
  echo 'The working directory is:' ${WORKDIR}
endif
echo
#
# First make sure we are where we are supposed to be !
#
if ( -e $WORKDIR ) then
  cd $WORKDIR
else
  echo 'The working directory does not exist'
  goto exitlab
endif
#
if ( ! $remote ) then
  echo 'ARP/wARP will run in the subdirectory:' $arpwarpdir
endif
#
#
# That will make the main run directory for this one ...
#
if ( -e $arpwarpdir ) /bin/rm -f -r $arpwarpdir
#
mkdir $arpwarpdir
#
#
cd $arpwarpdir
#
set rsfitwater = ''
#
set rrsig = `echo $rsig | awk '{print $1 + 0.4}'`
#
set freename = 'DUM' 
#
# Set flag for solvent mask correction
if ( $solvent ) then
  set bsolvent = 'SOLVENT YES'
else
  set bsolvent = ''
endif
#
set atomupdate = 'allatoms'
set mergedist = '0.7'
#
# Decide name for the running directory and go there ...!
# Largely UNneccessary for ccpish but kept for compatibility ...!
#
set filesloc = ${WORKDIR}'/'${JOB_ID}'_'
#
#===================================
# Setup logfiles and few more params
#===================================
#
set prefix = ${arpwarpmode}
set logf = ${WORKDIR}/${JOB_ID}_${prefix}_refine.log
set lastf = ${WORKDIR}/${JOB_ID}_${prefix}_refine.last.log
set tabf = ${WORKDIR}/${JOB_ID}_${prefix}_refine.loggraph
#
#
set logfb = ${WORKDIR}/${JOB_ID}_${prefix}_build.log
set lastfb = ${WORKDIR}/${JOB_ID}_${prefix}_build.last.log
set tabfb = ${WORKDIR}/${JOB_ID}_${prefix}_build.loggraph
set logomega = ${WORKDIR}/${JOB_ID}_${prefix}_omega.log
#
if ( -e $logf ) /bin/rm -f $logf
if ( -e $lastf ) /bin/rm -f $lastf
if ( -e $tabf ) /bin/rm -f $tabf
touch $logf
touch $lastf
touch $tabf
#
if ( -e $logfb ) /bin/rm -f $logfb
if ( -e $lastfb ) /bin/rm -f $lastfb
if ( -e $tabfb ) /bin/rm -f $tabfb
touch $logfb
touch $lastfb
touch $tabfb
#
#
#===========================================================
#
# Prepare the start files here ... one way or the other ...
#
if ( $modeccp4i == 'WARPNTRACEPHASES' ) then
  echo 'Building free atoms model'
#warp_building


	set lastprog = 'WARP_BUILD_SCRIPT'
	if ( $models > '3' ) set models = '3'
	#
	set logf =  ${WORKDIR}'/'${JOB_ID}'_warp_build.log'
	set tempfilesloc = ${WORKDIR}'/'${arpwarpdir}'/'${JOB_ID}'_'
	set filesloc = ${WORKDIR}'/'${JOB_ID}'_'
	#
	set lastlogfile = $logf
	#
# Here we cheat fft by supplying false resolution to get desired grid.
# fft will thus use maximum resolution for fft , but very fine grid of ~0.4 A !
	set eresol = `echo $resol | awk '{print $1 " 1.2"}' `
#
#
	if ( $fom == '' ) then
	  set labelscad = 'E1='$fbest' E2='$phibest
	  set typeincad = 'E1=F E2=P'
	  set labelsfft = 'F1='$fbest' PHI='$phibest
	  echo ' Initial map will be calculated with pre-weighted amplitudes ...'
	else
	  set labelscad = 'E1='$fp' E2='$phibest' E3='$fom
	  set typeincad = 'E1=F E2=P E3=W'
	  set labelsfft = 'F1='$fp' PHI='$phibest' W='$fom
	  echo ' Initial map will be calculated with amplitude weighted by extra weight ...'
	endif
#
#
# cad anyhow a new file ....
# If exp. phases resolution cutoff is given then resol will be cutoff ...
	set lastprog = CAD
#
cad hklin1 ${datafile} hklout ${tempfilesloc}temp.cad > ${logf} <<EOF
RESOL  OVER_ALL $eresol
LABIN  FILE 1 $labelscad
CTYPIN FILE 1 $typeincad
LABOUT FILE 1 $labelscad
END
EOF
#
	if ($status) goto exitlab
#
	set lastprog = FFT
fft hklin ${tempfilesloc}temp.cad mapout ${tempfilesloc}temp.map >>  ${logf} <<EOF
LABIN $labelsfft
RESOL $eresol
END
EOF
	if ($status) goto exitlab
#

	set lastprog = MAPMASK
mapmask mapin ${tempfilesloc}temp.map mapout ${tempfilesloc}arp_in.map >> ${logf} <<EOF
XYZLIM ${xyzlim}
EOF
	if ($status) goto exitlab
#
	/bin/rm ${tempfilesloc}temp.map
#
	/bin/echo ' Initial map calculated with ALREADY weighted amplitude ...'
#
	echo ' Now building '$models' initial model(s)'
# 
# 
	set freename = 'DUM' 
#
	set lastprog = ARP_WARP_BUILD
$warpbin/arp_warp >> ${logf} <<EOF
MODE MIRBUILD
FILES CCP4 MAPFIND ${tempfilesloc}arp_in.map XYZOUT1 ${filesloc}mir_model_1.pdb XYZOUT2 ${filesloc}mir_model_2.pdb XYZOUT3 ${filesloc}mir_model_3.pdb
SYMM ${sym}
CELL ${cell}
RESOLUTION ${resol}
MIRBUILD ATOMS $protsize MODELS ${models} RESN $freename
END
EOF
	if ($status) goto exitlab
#
# Printout if there is a cell difference

	set celldiff = `grep "Cells differ:" ${logf} | wc -l | awk '{print $1}' `

	if ( $celldiff != "0" ) then
	  echo $boldon
	  grep "Cells differ:" ${logf}
	  echo
	  echo ' If you are using a muti-dataset MTZ file, there might be a confusion'
	  echo ' between the MASTER cell and other cells. The job will continue.'
	  echo ' However, please consider re-building the MTZ so that it contains one'
	  echo ' dataset only, and then re-submitting ARP/wARP.'
	  echo
	  echo $boldoff
	endif
	set lsig = `grep 'sigmas )' ${logf} | tail -1 | awk '{print $5}'`
#
	echo ' Had to go as low as '$lsig' sigma, to complete atoms search.'
	echo
#
	set cmod = 0
#
	while ( $cmod < $models )
	  @ cmod++
#
	end
#
	/bin/rm -f ${tempfilesloc}temp.cad ${tempfilesloc}arp_in.map
#

#warp_building_end
  cp ${filesloc}mir_model_1.pdb arp_0.pdb
else
  echo 'Taking the input model '$modelin
  cp $modelin arp_0.pdb
endif
#
echo
#
# Done here as well with no real reason except stupid programming
set labout = 'FC=FC PHIC=ALPHA FWT=FWT PHWT=PHWT DELFWT=DELFWT PHDELWT=PHDELWT'
set labinfft21  = 'F1=FWT    PHI=PHWT'
set labinfft11  = 'F1=DELFWT PHI=PHDELWT'
#
# Add standard report here !!!
echo ' ARP/wARP will be iterated with REFMAC5'
echo ' '$restrcyc 'refinement / model update cycles will be run in total.'
#
echo ' Atoms will be removed below '$rsig' sigma in 2mFoDFc map and added above '$fsig' sigma in mFoDFc map.'
#
echo
echo ' Refmac Refinement Parameters'

echo '   '${rrcyc}' REFMAC cycle(s) with '${damp}' fractional shifts damping in each cycle.'
echo '   Weight for restraints is set to '$wmat' '${weightv}

if ( $freer == 'Y' ) then
    if ( $freerml == 'Y') then
	echo '   FreeR will be used for monitoring and sigmaa calculations.'
    else
	echo '   FreeR will only be used for monitoring.'
    endif
else
    echo '   FreeR will not be used.'
endif
if ( $solvent == '1' ) then
  echo '   Solvent mask correction will be used'
endif
#
if ( $scale == 'BULK' ) then
    if ( $scanis == 'Y' ) then
	echo '   Anisotropic scaling with bulk solvent correction'
    else
	echo '   Simple scaling with with bulk solvent correction'
    endif
else
    if ( $scanis == 'Y' ) then
	echo '   Anisotropic scaling, No bulk solvent correction'
    else
	echo '   Simple scaling, No bulk solvent correction'
    endif
endif
#
echo
#   
if ( $arpwarpmode == 'warpNtrace' ) then
  echo ' Model Building Parameters'
  echo '   Autobuilding will take place every '$restrref' refinement / model update cycles.'
  if ( $side >= 0 ) then
    echo '   Side chain docking will be performed from autobuilding cycle number '$side 
  endif
#
  if ( $whichtrace == '1' ) then
    echo '   Main Chain tracing will use the di-peptide search algorithm (hmain/pept)'
  else
    echo '   Main Chain tracing will use the peptide-search algorithm (cubes/pept_hmain)'
  endif
#
  if ( $skip != 0 ) then
    echo '   Autobuilding will be skipped the first '$skip' times.'   
  endif
#
  if ( $freebuild == '1' && $flatten == '1' ) then
    echo '   In place of the first autobuilding, solvent flattening will be performed.'
    echo '   A free atoms model will be constructed in the solvent flattened map.'
  endif
  if ( $freebuild == '1' && $flatten == '0' ) then
    echo '   In place of the first autobuilding, a new free atoms model '
    echo '   will be constructed in the 2mFo-DFc refmac map.'
  endif
#
  if ( ${randtimes} >= '1' ) then
    echo '   In place of autobuilding cycle nr.'$rand1' random shifts of '$randshift1' will be applied.'
  endif
  if ( ${randtimes} >= '2' ) then
    echo '   In place of autobuilding cycle nr.'$rand2' random shifts of '$randshift2' will be applied.'
  endif
  if ( ${randtimes} == '3' ) then
    echo '   In place of autobuilding cycle nr.'$rand1' random shifts of '$randshift3' will be applied.'
  endif
endif
#
echo ' '
#
#
#######################################
mainstart:
#######################################
#
#
# Put some pre-ambles to the table file for loggraph
#
echo '$TABLE: Refinement statistics:' >>${tabf}
echo '$GRAPHS: Rfactor v. Cycle nr :N:1,2:' >>${tabf}
echo ': Rfactor and Rfree v. Cycle nr :N:1,2,3:' >>${tabf}
echo ': Working set refinement indicators v. Cycle nr :N:1,2,4,6:' >>${tabf}
echo ': Working and free set refinement indicators v. Cycle nr :N:1,2,3,4,5,6,7:' >>${tabf}
echo ': Atoms added and removed v. Cycle nr :N:1,8,9:' >>${tabf}
echo ': Bonds rms v. Cycle nr :N:1,11:' >>${tabf}
echo ': Angles rms v. Cycle nr :N:1,12:' >>${tabf}
echo '$$' >>${tabf}
echo '  Cycle Rfactor Rfree Fo_Fc_corr Fo_Fc_free_corr FOM free_FOM Atoms_add Atoms_remove Total_atoms Rms_bonds Rms_angles ' >>${tabf}
echo '$$' >>${tabf}
echo '  Cycle Rfactor Rfree Fo_Fc_corr Fo_Fc_free_corr FOM free_FOM Atoms_add Atoms_remove Total_atoms Rms_bonds Rms_angles ' >>${tabf}
echo '$$' >>${tabf}
#
#
echo '$TABLE: Building statistics:' >>${tabfb}
echo '$GRAPHS: Connectivity index v. Cycle nr :N:1,4:' >>${tabfb}
echo ': Fragments and residues v. Cycle nr :N:1,2,3,5,6:' >>${tabfb}
echo '$$' >>${tabfb}
echo '  Cycle Fragments Residues Connectivity_index DockedFragments DockedResidues' >>${tabfb}
echo '$$' >>${tabfb}
echo '  Cycle Fragments Residues Connectivity_index DockedFragments DockedResidues' >>${tabfb}
echo '$$' >>${tabfb}
#
#
#=========================
# Here is the main code 
#=========================
#
#
#
set name = 'arp_'
set last   = '0'
#
set count  = '0'
set finalblock = '0'
#
#
# Here starts the cycling for the refinement/autobuilding
#
#
while ($count != $restrcyc)
#
#
if ( -e ${lastf} ) /bin/rm -f ${lastf}
#
@ next = $last + 1
#
# To start with see how much to add/remove in this cycle run
#
  set rh = `echo $resol | awk '{print $2}'`
  set goal = `echo $protsize $rh| awk '{print int($1*((0.2/($2*$2))+1.1))}'`
  set rr = `echo $resol | awk '{print $2*$2*$2}'`
  set atnow = `grep 'ATOM  ' ${name}${last}.pdb | grep '  1.00 ' | wc -l `
  @ idealtofind = ( ${goal} - ${atnow} ) / ${restrref}
  @ find = `echo $atnow $rr $upmore | awk '{printf"%4d\n",$3*0.08*$1/$2}'`
  if ( $find == '0' ) set find = 3
  if ( ${idealtofind} > ${find} ) @ find = ${idealtofind}
  @ rem  = $find - ( $goal - $atnow ) / ${restrref}
  @ ttt = $find / 2
  if ( ${rem} < $ttt ) set rem = $ttt
  if ( ${goal} < ${atnow} ) @ find = ${find} / 2 
#
# Lets check now if this is AFTER the last autobuilding
# In that case mode goes from allatoms to waters
#
  if ( $last > $restrcyc - $restrref && $arpwarpmode == 'warpNtrace' && $finalblock == '0' ) then
    set finalblock = '1'
    set atomupdate = 'waters'
#
    if ( $seqcovermode == "wat" ) then
      echo ' ---> Final restrained refinement block. Update only waters.'
      set rsfitwater = `echo $rh | awk '{if ($1>2.2) print " " ; else print "REFINE WATERS"}'`
      set mergedist = '2.2'
      set rsig = '1.0'
      set fsig = '3.4'
      set rem = $find
      set freename = 'WAT'
    else
      echo ' ---> Final restrained refinement block. No atom update.'
      set rsig = -50.0
      set fsig = 50.0
    endif
  endif
#
#
# Get rid of 0 atoms ...!
#
    grep -v ' 0.000   0.000' ${name}${last}.pdb > t1.tmp
    mv t1.tmp ${name}${last}.pdb
#
#
#
###########################
#	NEW REFMAC BLOCK
#	NEW REFMAC BLOCK
#	NEW REFMAC BLOCK
###########################
#
#
  @ cyccheck = $restrcyc - 2 * $restrref
#
  set lastlogfile = ${lastf} 
  set lastprog = 'REFMAC5'
$CBIN/refmac5 \
HKLIN ${datafile} XYZIN ${name}${last}.pdb XYZOUT ${name}${next}.pdb \
      HKLOUT ${name}${next}.mtz >> ${lastf} << e
MAKE HYDR N
MAKE CHECK 0
LABIN FP=$fp SIGFP=$sigfp $freelabin $phaselabin
LABO FC=FC PHIC=PHIC FWT=2FOFCWT PHWT=PH2FOFCWT -
     DELFWT=FOFCWT  PHDELWT=PHFOFCWT
REFI RESOLUTION ${resol} TYPE RESTR
REFI RESI ${refmax} $phaseref
REFI BREF ISOTropic
WEIGHT ${wmat} ${weightv}
DAMP ${damp} 
SCALE TYPE  ${scaleopt}
${scalml}
${bsolvent}
NCYC ${rrcyc}
MONI MANY
BLIMI 2 150
BINS 20
VDWR OVERALL 1.0 SIGMA DUMMY 0.05 INCREMENT DUMMY -1.0
END
e
#
if ($status) goto exitlab
#
#
#
# If this is just after building or the first cycle print some ratios ...
# 
  @ flag = ($last - 1) % $restrref
#
  if ( $flag == 0 || $last == 0 ) then
    set xray = `grep 'Number of used reflections' ${lastf} | tail -1 | awk '{print $6}' `
    set compl = `grep 'Percentage observed ' ${lastf} | tail -1 | awk '{printf"%4.2f\n",$4}' `
    set refatoms = ` grep 'ATOM  ' ${name}${next}.pdb | wc -l | awk '{print $1}' `
    set nrdist = `grep 'Bond distances: refined atoms' ${lastf} | tail -1 | awk '{print $5}' `
    set ratio = `echo $xray $refatoms | awk '{printf"%4.2f\n",(($1)/($2*4))}'`
    if ( "$nrdist" == '' ) set nrdist = '0'
#
    echo '   '$xray 'reflections (' $compl' % complete ) and ' $nrdist' restraints for refining '$refatoms' atoms.'
    echo '   Observations/parameters ratio is '$ratio
    echo '------------------------------------------------------'
#
  endif
#
# If it is the first cycle then print starting R !
  if ( $last == 0 ) then
    set rfac = `grep "Overall R factor"  ${lastf} | head -1 |awk '{printf"%8.3f\n",$5}'`
    set freerfac = `grep "Free R factor"  ${lastf} | head -1 |awk '{printf"%8.3f\n",$5}'`
    set fomover = `grep "Overall figure of merit "  ${lastf} | head -1 |awk '{printf"%8.3f\n",$6}'`
    set freefom = `grep "free_FOM"  ${lastf} | head -1 |awk '{printf"%8.3f\n",$2}'`
    set fofc = `grep "Overall correlation coefficient"  ${lastf} | head -1 |awk '{printf"%8.3f\n",$5}'`
    set freefofc = `grep "Free correlation coefficient"  ${lastf} | head -1 |awk '{printf"%8.3f\n",$5}'`
    if ( "$freerfac" == '' ) set freerfac = '0.000'
    if ( "$freefofc" == '' ) set freefofc = '0.000'
    if ( "$freefom" == '' )  set freefom  = '0.000'
#
    set atcycle = `grep -c 'ATOM  ' ${name}${next}.pdb `
#
    echo -n ' Starting model: ' 
    echo ' R = '$rfac '(Rfree = '$freerfac'). '
    echo '------------------------------------------------------'
#
    echo $last $rfac $freerfac $fomover $freefom $fofc $freefofc 0 0 $atcycle 0 0 >> ${tabf}
  endif
#

# Print R factors after this run ...
  set rfac = `grep "Overall R factor"  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$5}'`
  set freerfac = `grep "Free R factor"  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$5}'`
  set fomover = `grep "Overall figure of merit "  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$6}'`
  set freefom = `grep "free_FOM"  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$2}'`
  set fofc = `grep "Overall correlation coefficient"  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$5}'`
  set freefofc = `grep "Free correlation coefficient"  ${lastf} | tail -1 |awk '{printf"%8.3f\n",$5}'`
  if ( "$freerfac" == '' ) set freerfac = '0.000'
  if ( "$freefofc" == '' ) set freefofc = '0.000'
  if ( "$freefom" == '' ) set freefom = '0.000'
#
  echo -n '  Cycle '$last':' 
  if ( $last < 100 ) then
    echo -n ' '
  endif
  if ( $last < 10 ) then
    echo -n ' '
  endif
#
#
  echo ' After refmac, R = '$rfac '(Rfree = '$freerfac').'
  set rmsdist = ` grep 'Bond distances: refined atoms' ${lastf} | tail -1 | awk '{print $6}' `
  set rmsang  = ` grep 'Bond angles  : refined atoms' ${lastf} | tail -1 | awk '{print $7}' `
  if ( $rmsdist == '' ) set rmsdist = '0'
  if ( $rmsang == '' ) set rmsang = '0'
#
#
#  Sigmaa style 2mfo-dfc map with restored data
  set lastprog = 'FFT'
$CBIN/fft hklin ${name}${next}.mtz mapout map_2mfoDfc.map >> ${lastf}  <<eof
TITLE Sigmaa style 2mfo-Dfc map calculated with refmac coefficients
LABIN F1=2FOFCWT PHI=PH2FOFCWT
RESOLUTION       ${resol}
end
eof
#
if ($status) goto exitlab
#
#   Sigmaa style mfo-dfc map
$CBIN/fft hklin ${name}${next}.mtz mapout map_mfoDfc.map >> ${lastf} <<eof
TITLE Sigmaa style mfo-Dfc map calculated with refmac coefficients
LABIN F1=FOFCWT PHI=PHFOFCWT
RESOLUTION       ${resol}
end 
eof
#
if ($status) goto exitlab
#
#
  set lastprog = 'MAPMASK'
$CBIN/mapmask MAPIN map_2mfoDfc.map MAPOUT ${name}${next}_2mfoDfc.ext >> ${lastf}  << e
XYZLIM ${xyzlim}
END
e
#
#
if ($status) goto exitlab
  /bin/rm -f map_2mfoDfc.map
#
$CBIN/mapmask MAPIN map_mfoDfc.map MAPOUT ${name}${next}_mfoDfc.ext >> ${lastf}  << e
XYZLIM ${xyzlim}
END
e
#
#
if ($status) goto exitlab
/bin/rm -f map_mfoDfc.map
#
#
if ($status) goto exitlab
#
set arpsym = ${sym}
cp ${name}${next}.pdb arp_in.pdb
#
  set lastprog = 'ARP_WARP_MODE_UPDATE'
$warpbin/arp_warp >> ${lastf}  << e
MODE UPDATE ${atomupdate}
FILES CCP4 XYZIN arp_in.pdb MAPREMOVE ${name}${next}_2mfoDfc.ext MAPFIND ${name}${next}_mfoDfc.ext XYZOUT arp_out.pdb
SYMM       ${sym}
RESOLUTION ${resol}
REMOVE     ATOMS $rem CUTSIGMA ${rsig} MERGE ${mergedist}
FIND       ATOMS $find CHAIN Z CUTSIGMA ${fsig} RESN ${freename}
${rsfitwater}
END
e
#
  if ($status) goto exitlab
#
  set mergerem = `grep 'total have been removed' ${lastf}  | tail -1| awk '{print $1}' `
  set densrem = `grep 'will be removed' ${lastf} | tail -1| awk '{print $7}' `
  set found = `grep 'New atoms found' ${lastf} | tail -1| awk '{print $2}' `
  @ allrem = $mergerem + $densrem
  echo  '             Found '$found' ('$find' requested) and removed ' $allrem' ('$rem' requested) atoms.'
#
  set atcycle = `grep -c 'ATOM  '  ${name}${next}.pdb `
#
# Time to write out info for the table !
  echo $next $rfac $freerfac $fomover $freefom $fofc $freefofc $found $allrem $atcycle $rmsdist $rmsang >>${tabf}
#
  cat ${logf} ${lastf} > t
  mv t ${logf}
#
# Here we handle the autobuilding
#  if correct cycle is reached.
  @ flag = $last % $restrref
  @ bc = $last / $restrref
#
  if ( $arpwarpmode == 'atomupdate' ) then
    set flag = 1
  else
    if ( $skip > $bc && $flag == 0 ) then
      echo
      echo '  Will skip this building ...'
      echo
      set flag = 1
    endif
  endif
#
# FREEBUILD IN REFMAC , DM ETC ETC
  if ( $freebuild == '1' && $flag == '0' && $skip == $bc ) then
#
    echo
    echo '------------------------------------------------------'
#
    if ( ! $auto ) then
      set freelog = ${WORKDIR}'/'${JOB_ID}'_newfree_build.log'
    else
      set freelog = ${WORKDIR}'/newfree_build.log'
    endif
    if ( -e ${freelog}) then 
      /bin/rm -f ${freelog}
    endif
    touch ${freelog}
#
#
    if ( $flatten == 0 ) then
#
# Just calculate latest refmac map for putting atoms in
      echo 
      echo ' Recalculating latest refmac map in fine grid.'
#
      set lastprog = 'FFT'
$CBIN/fft hklin ${name}${next}.mtz mapout arp_in.map \
>> ${freelog}  <<eof
TITLE Sigmaa style 2mfo-Dfc map calculated with refmac coefficients
LABIN F1=2FOFCWT PHI=PH2FOFCWT
RESOLUTION  20.0 1.2 
end
eof
#
      if ($status) goto exitlab
#
    else
#
# First flatten, then calculate map to put free atoms in ...
      echo
      echo ' Solvent flattening now' 
#
      set lastprog = 'DM'
#
$CBIN/dm hklin ${name}${next}.mtz hklout dm.mtz >> ${freelog} <<eof
RESOLUTION ${resol}
SOLC ${solventc} 
MODE SOLV HIST
NCYCLE 20
LABIN FP=${fp} SIGFP=${sigfp} PHIO=PHIC FOMO=FOM
LABOUT PHIDM=PHIDM FOMDM=FOMDM
eof
#
      if ($status) goto exitlab
#
      echo ' Calculating solvent flattened  map in fine grid'
      set lastprog = 'FFT'
$CBIN/fft hklin dm.mtz mapout arp_in.map >> ${freelog}  << eof
TITLE Sigmaa style 2mfo-Dfc map calculated with refmac coefficients
LABIN F1=${fp} PHI=PHIDM W=FOMDM
RESOLUTION  20.0 1.2
END
eof
#
      if ($status) goto exitlab
#
    endif
    set lastprog = 'MAPMASK'
$CBIN/mapmask mapin arp_in.map mapout arp_in.ext >> ${freelog} <<EOF
XYZLIM ${xyzlim}
EOF
#
    if ($status) goto exitlab
#
    echo ' Building free atoms model in new map'
#
    set lastprog = 'ARP_WARP_MODE_MIRBUILD'
$warpbin/arp_warp >> ${freelog} <<EOF
MODE MIRBUILD
MIRBUILD ATOMS ${protsize} MODELS 1 RESN ${freename}
FILES CCP4 MAPFIND arp_in.ext XYZOUT1 arp_out.pdb 
SYMM ${sym}
CELL ${cell}
RESOLUTION ${resol}
END
EOF
#
    if ($status) goto exitlab
#
# Printout if there is a cell difference
    set celldiff = `grep "Cells differ:" ${freelog} | wc -l | awk '{print $1}' `
    if ( $celldiff != "0" ) then
      echo $boldon
      grep "Cells differ:" ${logf}
      echo
      echo ' If you are using a muti-dataset MTZ file, there might be a confusion'
      echo ' between the MASTER cell and other cells. The job will continue.'
      echo ' However, please consider re-building the MTZ so that it contains one'
      echo ' dataset only, and then re-submitting ARP/wARP.'
      echo
      echo $boldoff
    endif
#
    set lsig = `grep 'sigmas )' ${freelog} | tail -1 | awk '{print $5}'`
    echo ' Had to go as low as '$lsig' sigma, to complete atoms search.'
    echo ' Free atoms will be refined for one more big cycle.'
    echo 
    set flag = 1
#
    echo '------------------------------------------------------'
    echo
#
  endif
#
# Randomisation instead of building ???
  if ( $flag == 0 && (( $rand1 == $bc && $randtimes >= 1 ) || ( $rand2 == $bc && $randtimes >= 2 ) || ( $rand3 == $bc  && $randtimes == 3 ) )) then
#
    echo '------------------------------------------------------'
    echo '  Will skip this building and will shake the model instead ...'
#
    mv arp_out.pdb to_be_shaked_${bc}.pdb
#
    set bup = $wilsonb
    set bdown = `echo $wilsonb 2 | awk '{print $1/$2}'`
#
    if ( $rand3 == $bc ) then
      set rtimes = 'Third'
      set bcut = $bcut3
      set randshift = $randshift3
    endif
    if ( $rand2 == $bc ) then
      set rtimes = 'Second'
      set bcut = $bcut2
      set randshift = $randshift2
    endif
    if ( $rand1 == $bc ) then
      set rtimes = 'First'
      set bcut = $bcut1
      set randshift = $randshift1
    endif
#
#
    set wilsoncut = `echo $wilsonb $bcut | awk '{print $1*$2}'`
#	
    set lastprog = 'ARP_WARP_MODE_SHAKE'





#
set wilsoncut = `/bin/echo $wilsonb $bcut | awk '{print $1*$2}'`
#	
set lastprog = ARP_WARP_MODE_SHAKE
#
$warpbin/arp_warp >>${lastf} <<EOF
MODE shakemodel light
FILES CCP4 XYZIN to_be_shaked_${bc}.pdb XYZOUT after_shake_${bc}.pdb
SYMM ${sym}
SHAKEMODEL BEXCL $wilsoncut BRESET $bup $bdown RANDOMISE ${randshift}
END
EOF
#
if ($status) goto exitlab
    echo '  '$rtimes' randomisation, xyz shifts of '$randshift
    echo '   B factor cutoff '$wilsoncut' and B factor reset between '$bdown' and '$bup
    echo '------------------------------------------------------'
#
    cp after_shake_${bc}.pdb arp_out.pdb
#
    set flag = 1
#
  endif
#
# START OF BUILDING 
# START OF BUILDING 
# START OF BUILDING 
#
  if ($flag == 0 ) then
#
# Getting atomic shape factor (two_omega)
    set nres = `echo $protsize | awk '{print int($1/8)}'`
#
    set lastprog = 'ARP_MODE_WILSON'
${warpbin}/arp_warp > ${logomega} << e
MODE WILSON NRES ${nres}
FILES CCP4 HKLIN ${name}${next}.mtz
RESOLUTION ${resol}
LABELS     FP=$fp SIGFP=$sigfp FUSE=2FOFCWT
END
e
#
#
    if ($status) goto exitlab
#
    set twoomega       = `grep "Two_omuse"  ${logomega} | awk '{printf"%6.2f\n",$8}'`
    set twoomegares    = `echo $twoomega | awk '{printf"%6.2f\n",(($1/2-0.32)/0.17)}'`
    set twoomegarespar = `echo $twoomegares' '$solventc | awk '{printf"%6.2f\n",($1*((1/$2-1)^0.333))}'`
#
    echo '------------------------------------------------------'
    echo ' Building Cycle '$bc'    Atomic shape factors  '$twoomegares'  '$twoomegarespar
#
    set ccc = 1 
#
    cp arp_out.pdb trace_in_${ccc}.pdb
#
#    @ multic = $multit + 1
#
# Making sure that ${lastfb} is empty (but present)...
    if ( -e $lastfb ) /bin/rm -f $lastfb
    touch $lastfb
#

# Call for albe
    if ( $albe ) then
#
      set lastprog = 'ALBE' 
      set lastlogfile = ${lastfb} 
$warpbin/auto_albe.sh datafile ${name}${next}.mtz \
      residues $nres \
      workdir ${WORKDIR}/${arpwarpdir} \
      helixfileout albe_${bc}.pdb \
      jobId ${JOB_ID}_albe_${bc} \
      fp 2FOFCWT sigfp $sigfp phib PH2FOFCWT fom none >>& ${lastfb}
#
      if ( $status ) goto exitlab
#
#  Convert the outcome to DU0/DUM atoms and copy to arpwarpdir
      grep 'ATOM  ' ${WORKDIR}/${arpwarpdir}/${JOB_ID}_albe_${bc}/albe_${bc}.pdb | sed -e 's/GLY/DUM/g' -e 's/ALA/DUM/g' -e 's/VAL/DUM/g' -e 's/SER/DUM/g' -e 's/ C  /DU0 /g' -e 's/ N  /DU0 /g' -e 's/ O  /DU0 /g' -e 's/ CA /DU0 /g' -e 's/ CB /DU0 /g' -e 's/ OG /DU0 /g' -e 's/ CG2/DU0 /g' -e 's/ CG1/DU0 /g' > albe_out_${bc}.pdb
#
# Merge the ALBE file and the trace_in file
      cat albe_out_${bc}.pdb >> trace_in_${ccc}.pdb
      /bin/rm -rf ${JOB_ID}_albe_${bc}
#
      set alberes = `grep 'Chain fragments' ${lastfb} | tail -1 | awk '{print $2}'`
      set albetch = `grep 'Chain fragments' ${lastfb} | tail -1 | awk '{print $5}'`
      echo '   Search for helices and strands: '$alberes' residues in '$albetch' chains'
    endif
# Multiple rounds of main chain tracing
    while ($ccc <= $multit )   
#
      set adddummy = 'add_dummy'
#
      if ( $ccc == '1' ) then
        set score = '0'
      else
        set score = ( $score '0' )
      endif
#
      sed 's/   0.000 /   0.001 /g' trace_in_${ccc}.pdb > ttt.pdb
      mv ttt.pdb trace_in_${ccc}.pdb
#
      set lastlogfile = ${lastfb} 
#
# New tracing (7.0)
      if ( $whichtrace == '1' ) then
#
        set lastprog = 'HMAIN' 
$warpbin/hmain \
        xyzin trace_in_${ccc}.pdb \
        xyzref trace_in_${ccc}.pdb \
        mapin ${name}${next}_2mfoDfc.ext \
        LISTDAT hmain.res \
        DENSDAT $warpbin/hmain_dens.dat \
        TABLEDAT $warpbin/hmain_table.dat >> ${lastfb} << e 
RUN
SYMM $sym
RESO $resol
BWIL $wilsonb
LINK 5   7   0 1 2 3 4 5 6
LINK 6   2   1 5
END
e
#
        if ($status) goto exitlab
#
        set lastprog = 'PEPT'
$warpbin/pept \
        mapin1 ${name}${next}_2mfoDfc.ext \
        xyzin trace_in_${ccc}.pdb \
        LISTDAT hmain.res \
        xyzout trace_out_${ccc}.pdb >> ${lastfb} << e
SYMM $sym 
DUMM $adddummy
TERM NTR
LMIN 4
END
e
#
        if ($status) goto exitlab
#
# Old tracing (6.1)
      else
#
        set lastprog = 'CUBES' 
$warpbin/cubes \
        xyzin trace_in_${ccc}.pdb \
        xyzref trace_in_${ccc}.pdb \
        mapin ${name}${next}_2mfoDfc.ext \
        LISTDAT hmain.res \
        DENSDAT $warpbin/cubes_dens.dat \
        TABLEDAT $warpbin/cubes_table.dat >> ${lastfb} << e 
RUN
$sym
$resol
LINK 5   6   0 1 2 3 4 5
LINK 6   1   1
e
#
        if ($status) goto exitlab
#
        set lastprog = 'PEPT_HMAIN'
$warpbin/pept_hmain \
        mapin1 ${name}${next}_2mfoDfc.ext \
        xyzin trace_in_${ccc}.pdb \
        LISTDAT hmain.res \
        xyzout trace_out_${ccc}.pdb >> ${lastfb} << e
$sym 
$adddummy
END
e
        if ($status) goto exitlab
#
      endif
# Getting the number of peptides and chains as well as the current score
      set pepts = `grep 'onnectivity' ${lastfb} | tail -1 | awk '{print $6}'`
      set tch = `grep 'onnectivity' ${lastfb} | tail -1 | awk '{print $2}'`
      if ( $whichtrace == '1' ) then
        set connect     = `grep 'onnectivity' ${lastfb} | tail -1 | awk '{print $8}'`
        set tscore      = `grep 'Tracing_score' ${lastfb} | tail -1 | awk '{print $10}'`
        set score[$ccc] = `echo $connect $tscore | awk '{printf"%6.3f\n",($1+$2*2)/3}'`
      else
        set connect     = `grep 'onnectivity' ${lastfb} | tail -1 | awk '{print $12}'`
        set tscore      = `grep 'Tracing score' ${lastfb} | tail -1 | awk '{print $3}'`
        set scoretemp   = `echo $pepts' '$tch | awk '{print $1-2.0*$2}'`
        set score[$ccc] = `echo $scoretemp' '$tscore | awk '{print ($1+$2*2)/3}'`
      endif
#
# Get the best score
      if ( $whichtrace == '1' ) then
        set bestscore  = '0'
        set bestround  = '1'
        set roundcount = 0
        foreach try ( $score )
          @ roundcount++
          set evaluate = `echo $try $bestscore | awk '{if ($1-$2>0.0) print "1" ; else print "0" }'` 
          if ( $evaluate == '1' ) then
            set bestscore = $try
            set bestround = $roundcount
          endif
          set scorechange = ` echo $try' '$bestscore | awk '{print $1/$2}'`
        end
#    echo 'The best round so far '$bestround
#
# Decision making (7.0 tracing):
# If score is higher than the best score so far - interate the cycle
# Otherwise - leave the loop
# By the end or leave always take the top score 
        set evaluatescore = `echo $scorechange | awk '{if ($1>=1.0) print "iterate"} {if ($1<1.0) print "leave" }'` 
      else
        if ( $ccc == '1' ) then
          set scorechange = '2'
        else
          @ cccprev = $ccc - 1
          set scorechange = ` echo $score[$ccc]' '$score[$cccprev] | awk '{print $1/$2}'`
        endif
#
# Decision making (6.1.1):
# If score improved by more than 5% - interate the cycle
# If score improved by less than 5% - leave the loop
# If score became worse - take the previous result
        set evaluatescore = `echo $scorechange | awk '{if ($1>1.05) print "iterate" ; else print "leave" }'`
        set bestround = $ccc
        if ( $evaluatescore == 'leave' ) then
          set evaluatescore = `echo $scorechange | awk '{if ($1>=1.00) print "leave" ; else print "previous"}'`
          if ( $evaluatescore == 'previous' ) then
            set evaluatescore = 'leave'
            @ cccprev = $ccc - 1
            set bestround = $cccprev
          endif
        endif
      endif
#
# Printout
      set longestchain = `grep 'Chain #  1' ${lastfb} | tail -1 | awk '{print $7}'`
      if ( "$longestchain" == '' ) set longestchain = "0"
      echo '   Round '$ccc': '$pepts' peptides in '$tch' chains. The longest chain comprises '$longestchain' peptides.'
#  grep 'Chains residues' peptcomp.log
#  grep 'Total residues' peptcomp.log
#  grep 'Correct residues' peptcomp.log
#  grep 'Wrong residues' peptcomp.log
#
      if ( $evaluatescore == "leave" || $ccc == $multit ) goto skipnext
#
      @ cnext = $ccc + 1
      cp trace_out_${ccc}.pdb trace_in_${cnext}.pdb
      @ ccc++ 
    end
#
    skipnext:
    echo '   Taking the results from Round '$bestround
#
# Removing the DU0 and DU1 from the PDBs of input and output...
#  It is important to do so before going to SNOW ...
    grep -v "DU1  DUM" trace_out_${bestround}.pdb | grep -v "DU0  DUM" > ${name}pept_${bc}.pdb
#
# Cleanup
    /bin/rm -f trace_in_*.pdb
    /bin/rm -f trace_out_*.pdb
#
    if ( $side <= $bc && $side != -1 ) then
#
      set qcell = `echo "'"${cell}"'"`
#
      if ( $last < $restrcyc - $restrref ) then
        set shuffle = '0'
        set junkdum = '0'
      else
        set shuffle = '1'
        set junkdum = '0'
        echo
        echo '  Last building cycle: '
        echo '  Chain fragments will be rearranged'
      endif
#
      if ( -e seq.temp) /bin/rm -r -f seq.temp
#
# Uppercasing the sequence file
      set lastprog =  'UPPERCASING_SEQUENCE_FILE'
      awk '{print toupper($0)}' $seqin > seq.temp
      if ( $status ) goto exitlab
#
      echo > snow_msg.txt
      echo > ${name}snow_${bc}.pdb
#
      set lastprog = 'SNOW' 
$warpbin/snow -paramfile=- >>& ${lastfb} <<EOF
XMLOutputFilename = 'snow_log.xml'
KeepFragmentLongerThan = $lenfragexclude
IncludeChains = 
MessageFilename = snow_msg.txt
AbortLevel = 8
MessageLevel = 3
ProgramName = snow
DictionaryFilename = $warpbin/AAbis.XYZ
MinContactDist = 0.9
MaxContactDist = 1.7
DeleteUsedDummies = 0
MinCScore = 2
UniformAtomRadius = 0.74
AntiBumpFactor = 2.0
SymmetryFilename = $CLIBD/syminfo.lib
UniformAtomBFactor = $wilsonb
SpaceGroup = $sym 
XtalCell = $qcell 
PDBInputFilename = ${name}pept_${bc}.pdb
PDBOutputFilename =  ${name}snow_${bc}.pdb
NumberOfSequence = 1
SequenceFilename = seq.temp 
SequenceMultiplicty = ${cgr} 
MapFilename = ${name}${next}_2mfoDfc.ext 
ConformationGainThreshold = 1.0
PerformSequenceDocking = TopologyVectorThenRotamerDensityDocker 
PerformSideChainFitting = 1
PerformSideChainRefinement = 1 
PerformDummiesRejection = 0
PerformReshuffling = $shuffle 
RemoveAllDummies = $junkdum 
TopologyScoringScheme = BayesLikelihoodFilename
BayesLikelihoodFilename = $warpbin/likelihood_2.tbl
EOF
#
if ($status) goto exitlab
#
      set cindex = $score[$bestround]
      set cchains = `grep 'Number of fragment in the input PDB :' ${lastfb} | tail -1 | awk '{print $9}'` 
      set cres = `grep 'Number of residues in the input PDB :' ${lastfb} | tail -1 | awk '{print $9}'` 
      set dcchains = `grep 'Number of fragment docked (overall) :' ${lastfb} | tail -1 | awk '{print $7}'` 
      set dcres = `grep 'Number of residues docked (overall) :' ${lastfb} | tail -1 | awk '{print $7}'` 
#
      if ( $cres == '' ) then
        set cres    = '0'
        set cchains = '0'
      endif
      if ( $dcres == '' ) then
        set dcres    = '0'
        set dcchains = '0'
      endif
#
      echo $boldon
      if ( $whichtrace == '1' ) then
        set cindex = `echo ${resol}' '$cindex | awk '{ print 0.1*($2)^3*(1-$3)^2 }'`
        set cindex = `echo $cindex | awk '{ if ($1 < 1.0) printf"%5.1f\n",100*(1.0-$1) ; else print "0.0" }'`
        echo '  Chains '$cchains', Residues '$cres', Estimated correctness of the model '$cindex' %'
      else
        echo '  Chains '$cchains', Residues '$cres', Combined score '$cindex
      endif
      echo '  '$dcchains' chains ('$dcres' residues) have been docked in sequence'
      echo $boldoff
#
#set err = ` sort.csh  /home/ztony/a.mtz  ${name}${next}.mtz  PHIC PHIK FOM |  awk '{print $1}'`
#echo "$cindex  $cchains  $cres	 $dcchains  $dcres	 $freerfac  $rfac  $twoomegares  $twoomegarespar  $err" >> /#home/ztony/oasis_arp.log


#
echo $next $cchains $cres $cindex $dcchains $dcres >> ${tabfb}
#
# Check for no-solution while reshuffling fragments within Snow
if ( $shuffle == "1" ) then
  echo $boldon
        grep "WARNING : VERY likely the sequence docking" ${lastfb}
  echo $boldoff
endif
#
echo '------------------------------------------------------'
#
      cp ${name}snow_${bc}.pdb arp_out.pdb
#
#
#
      if ( $last >= $restrcyc - $restrref ) then
        set seqcover = `echo $dcres $cres | awk '{printf"%3d",100*$1/($2+1)}'` 
        echo $boldon
        echo ' Sequence coverage is '$seqcover' %'
        echo $boldoff
        set seqcovermode = `echo $seqcover | awk '{if ($1>80) print "wat" ; else print "dum" }'` 
#
        if ( $seqcovermode == "wat" ) then
          echo '  All DUM atoms will be removed'
          grep -v "DUM  DUM" arp_out.pdb > arp_out1.pdb
          mv arp_out1.pdb arp_out.pdb
        else
          echo $boldon
          echo ' Consider running further cycles of model building using '${JOB_ID}_$prefix'.pdb as input'
          echo $boldoff
        endif
      endif
#
    else
#
# RESHUFFLE is NO longer in use, use the PEPT output
      set cindex = $score[$bestround]
      set cchains = $tch
      @ cres = $pepts - $tch
#
      echo $boldon
      if ( $whichtrace == '1' ) then
        set cindex = `echo ${resol}' '$cindex | awk '{ print 0.1*($2)^3*(1-$3)^2 }'`
        set cindex = `echo $cindex | awk '{ if ($1 < 1.0) printf"%5.1f\n",100*(1.0-$1) ; else print "0.0" }'`
        echo '  Chains '$cchains', Residues '$cres', Estimated correctness of the model '$cindex' %'
      else
        echo '  Chains '$cchains', Residues '$cres', Combined score '$cindex
      endif
      echo $boldoff
#
      grep -v ' CTR' ${name}pept_${bc}.pdb | grep -v ' NTR' > ${name}resuf_${bc}.pdb
      cp ${name}resuf_${bc}.pdb arp_out.pdb
#
      set seqcovermode = "dum"
#
    endif
#
# Removing DUMs only on the basis of merging
    set lastprog = 'ARP_WARP_MODE_UPDATE_BUILD'
$warpbin/arp_warp >> ${lastfb} <<EOF
MODE UPDATE allatoms
FILES CCP4 XYZIN arp_out.pdb MAPREMOVE ${name}${next}_2mfoDfc.ext -
           MAPFIND ${name}${next}_mfoDfc.ext XYZOUT arp_out_1.pdb 
SYMM       ${sym}
RESOLUTION ${resol}
REMOVE     ATOMS 9999 CUTSIGMA -9.9 MERGE 0.7
FIND       ATOMS 1 CHAIN Z CUTSIGMA 9.9 RESN ${freename}
END
EOF
#
    if ($status) goto exitlab
#
# Estimating the number of DUM atoms still to be removed
    set curratomsarp  = `grep 'ATOM  ' arp_out_1.pdb | wc -l | awk '{print $1}'` 
    set maxremove1    = `echo ${curratomsarp}' '${goal} | awk '{printf"%5d",$1-$2*0.9}'`
    set maxremove     = `echo $maxremove1 | awk '{if ($1>0) print $1 ; else print "1" }'` 
#
# Removing DUMs only on the basis of density
    set lastprog = 'ARP_WARP_MODE_UPDATE_BUILD'
$warpbin/arp_warp >> ${lastfb} <<EOF
MODE UPDATE waters
FILES CCP4 XYZIN arp_out_1.pdb MAPREMOVE ${name}${next}_2mfoDfc.ext -
           MAPFIND ${name}${next}_mfoDfc.ext XYZOUT arp_out_2.pdb 
SYMM       ${sym}
RESOLUTION ${resol}
REMOVE     ATOMS ${maxremove} CUTSIGMA ${rrsig} MERGE 0.7
FIND       ATOMS 1 CHAIN Z CUTSIGMA 9.9 RESN ${freename}
END
EOF
#
#
    if ($status) goto exitlab
#
#
#
#
/bin/rm -f arp_out_1.pdb
mv arp_out_2.pdb arp_out.pdb
#
cat ${logfb} ${lastfb} >t
mv t ${logfb}
#
#
endif
#
# END OF BUILDING 
#
# Now, in case this is the VERY LAST cycle we should
# calculate a map which covers the newly build molecule.
#
if (-e ../STOP.EXE) then
    echo ' Cycling interrupted by user.'
    /bin/rm -f ../STOP.EXE
     @ next = $restrcyc
endif
#
if (-e ../ABANDON.EXE) then
    echo ' Program stopped by user.'
    /bin/rm -f ../ABANDON.EXE
    exit
endif
#
  if ( $next == $restrcyc) then
    echo
    echo '   Writing map files covering molecule ...'
#
    set lastprog = 'MAPMASK'
$CBIN/mapmask MAPIN ${name}${next}_2mfoDfc.ext MAPOUT ${filesloc}map_2mfoDfc_${prefix}.ext \
XYZIN arp_out.pdb >> ${logf}  << e
BORDER 5
END
e
#
    if ($status) goto exitlab
#
    cp ${name}${next}_2mfoDfc.ext ${filesloc}map_2mfoDfc_${prefix}.map 
#
$CBIN/mapmask MAPIN ${name}${next}_mfoDfc.ext MAPOUT ${filesloc}map_mfoDfc_${prefix}.ext \
XYZIN arp_out.pdb >> ${logf}  << e
BORDER 5
END
e
#
if ($status) goto exitlab
#
#
cp ${name}${next}.mtz ${filesloc}${prefix}.mtz    
#       
endif
#
#


/bin/rm -f ${name}${next}.pdb
cp arp_out.pdb ${name}${next}.pdb



@ mflag = $last % $restrref
if ( $mflag == 0 ) then
#



set seqcover = `echo $dcres $cres | awk '{printf"%3d",100*$1/($2+1)}'` 
set seqcovermode = `echo $seqcover | awk '{if ($1>80) print "wat"} {if ($1<=80) print "dum" }'` 

if ( $seqcovermode == "wat" ) then
   grep -v "DUM  DUM" arp_out.pdb > arp_out1.pdb
else
   rm -f  arp_out1.pdb
   cp arp_out.pdb arp_out1.pdb
endif

    if ( $seqcovermode == "wat" ) then
      set rsfitwater1 = `echo $rh | awk '{if ($1>2.2) print " " ; else print "REFINE WATERS"}'`
      set mergedist1 = '2.2'
      set rsig1 = '1.0'
      set fsig1 = '3.4'
      set rem1 = $find
      set freename1 = 'WAT'
    else
      set rsig1 = -50.0
      set fsig1 = 50.0
      set rem1 = $rem
      set rsfitwater1 = $rsfitwater
      set freename1 = $freename
      set mergedist1 = $mergedist
    endif

$warpbin/arp_warp > tmp.log << e
MODE UPDATE waters
FILES CCP4 XYZIN arp_out1.pdb MAPREMOVE ${name}${next}_2mfoDfc.ext MAPFIND ${name}${next}_mfoDfc.ext XYZOUT arp_out2.pdb
SYMM       ${sym}
RESOLUTION ${resol}
REMOVE     ATOMS $rem1 CUTSIGMA ${rsig1} MERGE ${mergedist1}
FIND       ATOMS $find CHAIN Z CUTSIGMA ${fsig1} RESN ${freename1}
${rsfitwater1}
END
e


rm -fr arp_out1.pdb
mv arp_out2.pdb arp_out1.pdb

#echo $dcres $cres $rfac $last
set ifsig = `echo $dcres" "$dcreslast | awk '{ if ( $1 >= $2) {print "true";}else{print "false" ;}  }'`
if ( $ifsig == "true") then
set dcreslast = $dcres
set di = $bc
set dc = $cres
set dr = $rfac
if ( $rfree_signal == 1  ) then
set drfree = $freerfac
endif
if ( -e arp_last.pdb ) rm -f arp_last_dres.pdb
cp arp_out1.pdb arp_last_dres.pdb
if ( -e arp_last.mtz ) rm -f arp_last_dres.mtz
cp ${name}${next}.mtz   arp_last_dres.mtz
endif




set ifsig = `echo $cres" "$creslast | awk '{ if ( $1 >= $2) {print "true";}else{print "false" ;}  }'`
if ( $ifsig == "true") then
set creslast = $cres
set cri = $bc
set crd = $dcres
set crr = $rfac
if ( $rfree_signal == 1  ) then
set crfree = $freerfac
endif
if ( -e arp_last.pdb ) rm -f arp_last_cres.pdb
cp arp_out1.pdb arp_last_cres.pdb
if ( -e arp_last.mtz ) rm -f arp_last_cres.mtz
cp ${name}${next}.mtz   arp_last_cres.mtz
endif


set ifsig = `echo $rfac" "$rlast | awk '{ if ( $1 <= $2) {print "true";}else{print "false" ;}  }'`
if ( $ifsig == "true") then
set rlast = $rfac
set ri = $bc
set rc = $cres
set rd = $dcres
if ( $rfree_signal == 1  ) then
set rrfree = $freerfac
endif
if ( -e arp_last.pdb ) rm -f arp_last_r.pdb
cp arp_out1.pdb arp_last_r.pdb
if ( -e arp_last.mtz ) rm -f arp_last_r.mtz
cp ${name}${next}.mtz   arp_last_r.mtz
endif


if ( $rfree_signal == 1 ) then
set ifsig = `echo $freerfac" "$rfree_rfree | awk '{ if ( $1 <= $2) {print "true";}else{print "false" ;}  }'`
if ( $ifsig == "true") then
set rfreelast = $rfac
set rfreei = $bc
set rfreec = $cres
set rfreed = $dcres
set rfree_rfree = $freerfac
if ( -e arp_last.pdb ) rm -f arp_last_rfree.pdb
cp arp_out1.pdb arp_last_rfree.pdb
if ( -e arp_last.mtz ) rm -f arp_last_rfree.mtz
cp ${name}${next}.mtz   arp_last_rfree.mtz
endif
endif

rm -f arp_out1.pdb
endif

/bin/rm -f ${name}${next}_2mfoDfc.ext
/bin/rm -f ${name}${next}_mfoDfc.ext
/bin/rm -f ${name}${next}.mtz


#
#
@ last++
@ count++
end
#

echo '$$' >> ${tabf}
/bin/rm -f ${lastf}
/bin/rm -f ${lastfb}
echo '$$' >>${tabfb}
#
#
#
echo $boldon
echo ' Normal termination of '$prefix 
echo $boldoff
#
# Go up from working directory
# Either $prefix for non-interface
# ... or $arpwarpdir for ccp4ish
#
cd ..
#
#
#
#

    cp ${arpwarpdir}/${name}${next}.pdb ${filesloc}$prefix.pdb
    cp ${filesloc}$prefix.pdb   ${main_path}/${name_c}_arp.pdb
    cp ${filesloc}${prefix}.mtz  ${main_path}/${name_c}_arp.mtz
    cp ${arpwarpdir}/arp_last_dres.pdb ${main_path}/${name_c}_arp_dres.pdb
    cp ${arpwarpdir}/arp_last_dres.mtz ${main_path}/${name_c}_arp_dres.mtz
    cp ${arpwarpdir}/arp_last_cres.pdb ${main_path}/${name_c}_arp_cres.pdb
    cp ${arpwarpdir}/arp_last_cres.mtz ${main_path}/${name_c}_arp_cres.mtz
    cp ${arpwarpdir}/arp_last_r.pdb ${main_path}/${name_c}_arp_r.pdb
    cp ${arpwarpdir}/arp_last_r.mtz ${main_path}/${name_c}_arp_r.mtz
    if ( $rfree_signal == 1 ) then
      echo "set recommend = ( $dcres $cres $rfac $freerfac )" >> ${main_path}/${name_c}_result.par
      echo "set dock_best = ( $dcreslast $dc $dr $di $drfree )" >> ${main_path}/${name_c}_result.par
      echo "set res_best = ( $crd $creslast $crr $cri $crfree)" >> ${main_path}/${name_c}_result.par
      echo "set r_best = ( $rd $rc $rlast $ri $rrfree)" >> ${main_path}/${name_c}_result.par
      echo "set rfree_best = ( $rfreed $rfreec $rfreelast $rfreei $rfree_rfree)" >> ${main_path}/${name_c}_result.par
      cp ${arpwarpdir}/arp_last_rfree.pdb ${main_path}/${name_c}_arp_rfree.pdb
      cp ${arpwarpdir}/arp_last_rfree.mtz ${main_path}/${name_c}_arp_rfree.mtz
    else
      echo "set recommend = ( $dcres $cres $rfac 0 )" >> ${main_path}/${name_c}_result.par
      echo "set dock_best = ( $dcreslast $dc $dr $di 0 )" >> ${main_path}/${name_c}_result.par
      echo "set res_best = ( $crd $creslast $crr $cri 0 )" >> ${main_path}/${name_c}_result.par
      echo "set r_best = ( $rd $rc $rlast $ri 0 )" >> ${main_path}/${name_c}_result.par
    endif
    /bin/rm -f -r ${arpwarpdir}

  endif

#
#
exit
exitlab:
# Printout if there is a cell difference
if ( ${lastprog} == "ARP_WARP_MODE_MIRBUILD" ) then
  set celldiff = `grep 'Cells differ:' ${freelog} | wc -l | awk '{print $1}' `
  if ( $celldiff != '0' ) then
    echo $boldon
    echo 
    grep 'Cells differ:' ${logf}
    echo
    echo ' If you are using a muti-dataset MTZ file, there might be a confusion'
    echo ' between the MASTER cell and other cells. The job must exit now.'
    echo ' Please consider re-building the MTZ so that it contains one'
    echo ' dataset only, and then re-submitting ARP/wARP.'
    echo
    echo $boldoff
  endif
endif
#
if ( ! $?lastprog ) set lastprog = $0
echo
echo $boldon
echo 'QUITTING ... ARP/wARP module stopped with an error message:'
echo ${lastprog}
echo
if ( $?lastlogfile ) then
  echo '*** Look for error message in the file: '
  echo ${lastlogfile}
  echo
endif
echo $boldoff
#
#
exit(1)
#



