#!/bin/tcsh 
####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2009,02,10
#last Edit: 2009,02,10
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: main states file
#3: interface file name
#4: chang parameters pool
###################################################################################

source $1
set name_c = ${name}_init
set stat_file = .par_tmp/${name_c}.sta

if ( -e $stat_file ) then
source $stat_file
goto $program
else
touch $stat_file
echo "set OASIS_MODE = EXT " >> $4
echo "set stat_file = $stat_file" >> $4
echo "set name_c = $name_c " >> $4
echo "set html_name = $html_name" >> $4
endif
echo "set mr_states = 0 " >> $2
echo "set mr_states = 0 " >> $stat_file
echo "set oasis_hklin = $oasis_hklin "	 >> $4

echo "set fof_signal = 0" >> $4
echo "set fom_signal = 0" >> $4
#echo "set hl_control_signal = $hl_control_signal" >> $4
echo "set hl_signal = 0" >> $4
#if ( $hl_signal == 1 ) then
#  echo "set hl_file = $hl_file" >> $4
#  echo "set HLA = $HLA" >> $4
#  echo "set HLB = $HLB" >> $4
#  echo "set HLC = $HLC" >> $4
#  echo "set HLD = $HLD" >> $4
#endif
echo "set sigma_signal = $sigma_signal" >> $4
if ( $sigma_signal == 1  ) then
  echo "set sigma_file = $sigma_file" >> $4
endif
echo "set ncs_signal = $ncs_signal" >> $4
if ( $ncs_signal == 1 ) then	
  echo "set ncs_file = $ncs_file" >> $4
endif

#prepare pdb file
#set init_pdb = ${name_c}_init.pdb
#$oasisbin/frc2pdb.csh $1 $oasis_frc $init_pdb
#echo "set init_pdb = $init_pdb " >> $4



#execute build program
build:
echo "set program = build" >> $stat_file
if ( $extend_model_program == "arp"  ) then
echo "set build_log = ${name_c}_arp.log"  >> $4
echo "set select_mode = $mr_arp_select_mode " >> $4
${oasisbin}/arpwarp_exe.csh $1 $4 $stat_file | tee ${name_c}_arp.log
else if ( $extend_model_program == "phenix" ) then
echo "set build_log = ${name_c}_phenix.log"  >> $4
echo "set select_mode = $mr_phenix_select_mode " >> $4
${oasisbin}/phenix_build_exe.csh $1 $4 $stat_file | tee  ${name_c}_phenix.log
endif
source $stat_file
if ( $build_status == 0 ) then
  goto exitmr;
endif
source $4



#show information
${oasisbin}/html/show.csh $4 $stat_file 0 $3 1 1
goto stop;

exitmr:
echo "set mr_states = 0 " >> $stat_file
echo "set mr_states = 0 " >> $2
${oasisbin}/html/show.csh $4 $stat_file 0 $3 0 1
source $4
if ( $program == "build" ) then
echo "set error_log = $build_log" >> $2
endif
exit

stop:
echo "set mr_states = 1 " >> $stat_file
echo "set mr_states = 1 " >> $2
