#!/bin/tcsh 
####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2009,02,10
#last Edit: 2009,02,10
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: frc file
#3: pdb file name
###################################################################################

source $1

rm -fr frc2pdb_tmp.frc frc2pdb_tmp.pdb

set atom_num = `awk 'BEGIN{n=0;} {n++;} END{print n;}' $2`

awk -v num=$atom_num '{printf"%5d%10.5f%10.5f%10.5f%10.5f%5.2f%5d%10d%-5s%-2s1\n",$2,$3,$4,$5,$7,$6,num,$2,$1,$1}' $2 > frc2pdb_tmp.frc

$CBIN/coordconv XYZOUT frc2pdb_tmp.pdb XYZIN frc2pdb_tmp.frc << end
input FRAC -
      orth 1
output PDB
cell $CELL_A $CELL_B $CELL_C $CELL_ALPHA $CELL_BETA $CELL_GAMMA
end
awk '/CRYST|SCALE/{print $0;} /^ATOM/{printf"%4s%7d%3s   DUM T%4d%40s%12s\n",$1,$2,$3,$2,substr($0,27,67),$3} ' frc2pdb_tmp.pdb > $3
rm -fr frc2pdb_tmp.pdb
rm -fr frc2pdb_tmp.frc
