#!/bin/tcsh 
####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,05,20
#last Edit: 2008,05,20
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: best parameters pool
#3: cycle number
###################################################################################

source $1
source $2

@ seq_num_tmp = $seq_num * $ncs_num
if ( $build_pro == "arp" ) then
  if ( $resulte[1] > $seq_num_tmp ) then
    @ this_result = $resulte[2] + $seq_num_tmp
  else
    @ this_result = $resulte[2] + $resulte[1]
  endif
else
  if ( $recommend[2] > $seq_num_tmp ) then
    @ this_result = $recommend[1] + $seq_num_tmp
  else
    @ this_result = $recommend[1] + $recommend[2]
  endif
endif
if ( -e $path_c/.par_tmp/result.par ) then
  source $path_c/.par_tmp/result.par
  if ( $this_result < $best_result ) then
     exit
  endif
endif

echo "set best_result = $this_result  " >$path_c/.par_tmp/result.par


if ( $?phase_out == 1 ) then
  if ( -e $phase_out ) then
    rm -f $main_path/phase_out.mtz
    cp $phase_out $main_path/phase_out.mtz
  endif
endif


if ( $?dm_out == 1 ) then
  if ( -e $dm_out ) then
    rm -f $main_path/dm_out.mtz
    cp $dm_out $main_path/dm_out.mtz
  endif
endif

if ( -e $build_mtz_out ) then
  rm -f $main_path/build_result.mtz
  cp $build_mtz_out $main_path/build_result.mtz
endif

if ( -e $build_pdb_out ) then
  rm -f $main_path/build_result.pdb
  cp $build_pdb_out $main_path/build_result.pdb
endif

if ( $3 == 1 || $3 == 0 ) then
  source ${oasisbin}/html/info.csh > ${path_c}/$html_name/info.htm
endif
