####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,05,19
#last Edit: 2008,05,19 
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: changed parameters pool
#3: states pool
#4: number of cycles
#5: number of seed
###################################################################################

source $1
source $2

echo "set phase_status = 0" >> $3
set phaser_csh = ${name_c}_phaser.csh
rm -fr  $phaser_csh
touch  $phaser_csh

echo "#\!/bin/tcsh" >>  $phaser_csh
echo " if ( -e ${name_c}_phaser_tmp ) then " >>  $phaser_csh
echo "echo 'A phaser is running now, please check ${name_c}_phaser_tmp and remove it'" >>  $phaser_csh
echo "else" >>  $phaser_csh
echo "mkdir ${name_c}_phaser_tmp"  >>  $phaser_csh
echo "cd ${name_c}_phaser_tmp" >>  $phaser_csh

#oasis command
echo  "phenix.phaser <<+ " >> $phaser_csh


# oasis script
echo "TITLe  $TIT"  >> $phaser_csh

echo "HKLIn $oasis_hklin" >> $phaser_csh


if ( $RES == "1" ) then 	
echo "RESOlution $RESOLUTION_MAX $RESOLUTION_MIN" >> $phaser_csh
endif

if ( "SAD" == $OASIS_MODE )  then
  echo "MODE EP_SAD" >> $phaser_csh
  if ( $MAP_FM == "1" )  then 
	goto exitphaser
   else 
	echo  "CRYSTAL oasis DATA sad LABIN F+=$FPP SIG+=$SIGFPP F-=$FPN SIG-=$SIGFPN"  >> $phaser_csh
  endif
  set ii = 1
  while ( $ii <= $HA_NUM )
	echo "ATOM CRYSTAL oasis ELEM $HA_TYPE[$ii] FRAC $HA_X[$ii] $HA_Y[$ii] $HA_Z[$ii] OCC $HA_OCC[$ii] ISOB $HA_B[$ii]" >> $phaser_csh
	@ ii++
  end
  echo "ATOM BFACTOR WILSON" >> $phaser_csh
endif

if ( "SIR" == $OASIS_MODE ) then
  goto exitphaser
endif

if ( "DMR" == $OASIS_MODE ) then 
  echo "MODE MR_AUTO" >> $phaser_csh
  echo "LABIN FP=$FP SIGFP=$SIGFP"  >> $phaser_csh
  echo "ENSEmble beta PDB $start_pdb IDENtity 100" >> $phaser_csh
  echo "SEARCH ENSEmble beta" >> $phaser_csh

endif
echo "COMPosition PROTein SEQuence $seqin NUM $ncs_num" >> $phaser_csh
echo "ROOT oasis_phaser" >> $phaser_csh
echo "+" >> $phaser_csh

if ( $hl_oasis_signal == 1  && "DMR" != $OASIS_MODE && $hl_signal == 0 ) then
  set hl_signal = 1
  set hl_file = $oasis_out
  set HLA = HLA
  set HLB = HLB
  set HLC = HLC
  set HLD = HLD
  echo "set hl_file = $hl_file" >> $2
  echo "set hl_signal = 1 " >> $2
  echo "set HLA = HLA" >> $2
  echo "set HLB = HLB" >> $2
  echo "set HLC = HLC" >> $2
  echo "set HLD = HLD" >> $2
endif

if ( "SAD" == $OASIS_MODE )  then
  echo  "${oasisbin}/fnp2fp HKLIN oasis_phaser.mtz HKLOUT oasis_fp.mtz <<+">> $phaser_csh
  echo  "LABIN F+=$FPP SIGF+=$SIGFPP F-=$FPN SIGF-=$SIGFPN">> $phaser_csh
  echo  "+">> $phaser_csh
  echo  "cad HKLIN1 oasis_fp.mtz HKLIN2 oasis_phaser.mtz <<+">> $phaser_csh
  if ( $hl_signal == 1 ) then
	echo -n "HKLIN3 $hl_file " >> $phaser_csh
  endif
  echo "HKLOUT oasis_phaser_mr.mtz<<+ " >> $phaser_csh
  echo		"monitor BRIEF" >> $phaser_csh
  echo		"labin file 1 -" >> $phaser_csh
  echo		    "E1 = FP -" >> $phaser_csh
  echo		    "E2 = SIGFP " >> $phaser_csh
  echo		"labout file 1 -" >> $phaser_csh
  echo		    "E1 = FP -" >> $phaser_csh
  echo		    "E2 = SIGFP " >> $phaser_csh
  echo		"ctypin file 1 -" >> $phaser_csh
  echo		    "E1 = F -" >> $phaser_csh
  echo		    "E2 = Q " >> $phaser_csh
  echo		"labin file 2 -" >> $phaser_csh
  echo		    "E1 = PHIB -" >> $phaser_csh
  echo		    "E2 = FOM " >> $phaser_csh
  echo		"labout file 2 -" >> $phaser_csh
  echo		    "E1 = PHIB -" >> $phaser_csh
  echo		    "E2 = FOM " >> $phaser_csh
  echo		"ctypin file 2 -" >> $phaser_csh
  echo		    "E1 = P -" >> $phaser_csh
  echo		    "E2 = W " >> $phaser_csh
endif

if ( "DMR" == $OASIS_MODE ) then 
  echo -n "cad HKLIN1 $oasis_hklin HKLIN2 oasis_phaser.1.mtz ">> $phaser_csh
  if ( $hl_signal == 1 ) then
	echo -n "HKLIN3 $hl_file " >> $phaser_csh
  endif
  echo "HKLOUT oasis_phaser_mr.mtz<<+ " >> $phaser_csh
  echo		"monitor BRIEF" >> $phaser_csh
  echo		"labin file 1 -" >> $phaser_csh
  echo		    "E1 = $FP -" >> $phaser_csh
  echo		    "E2 = $SIGFP " >> $phaser_csh
  echo		"labout file 1 -" >> $phaser_csh
  echo		    "E1 = FP -" >> $phaser_csh
  echo		    "E2 = SIGFP " >> $phaser_csh
  echo		"ctypin file 1 -" >> $phaser_csh
  echo		    "E1 = F -" >> $phaser_csh
  echo		    "E2 = Q " >> $phaser_csh
  echo		"labin file 2 -" >> $phaser_csh
  echo		    "E1 = FWT -" >> $phaser_csh
  echo		    "E2 = PHIC -" >> $phaser_csh
  echo		    "E3 = FOM " >> $phaser_csh
  echo		"labout file 2 -" >> $phaser_csh
  echo		    "E1 = FWT -" >> $phaser_csh
  echo		    "E2 = PHIB -" >> $phaser_csh
  echo		    "E3 = FOM " >> $phaser_csh
  echo		"ctypin file 2 -" >> $phaser_csh
  echo		    "E1 = F -" >> $phaser_csh
  echo		    "E2 = P -" >> $phaser_csh
  echo		    "E3 = W " >> $phaser_csh
endif

if ( $hl_signal == 1 ) then
	echo	"labin file 3 -" >> $phaser_csh
	echo "E1 = $HLA -" >> $phaser_csh
	echo "E2 = $HLB -" >> $phaser_csh
	echo "E3 = $HLC -" >> $phaser_csh
	echo "E4 = $HLD " >> $phaser_csh
	echo	"labout file 3 -" >> $phaser_csh
	echo "E1 = $HLA -" >> $phaser_csh
	echo "E2 = $HLB -" >> $phaser_csh
	echo "E3 = $HLC -" >> $phaser_csh
	echo "E4 = $HLD " >> $phaser_csh
	echo	"ctypin file 3 -" >> $phaser_csh
	echo "E1 = A -" >> $phaser_csh
	echo "E2 = A -" >> $phaser_csh
	echo "E3 = A -" >> $phaser_csh
	echo "E4 = A " >> $phaser_csh
endif
echo "+">> $phaser_csh
echo "cp oasis_phaser_mr.mtz ../${name_c}_phaser.mtz" >> $phaser_csh
echo "cp oasis_phaser.1.pdb ../${name_c}_phaser.pdb" >> $phaser_csh
set phaser_out = ${name_c}_phaser.mtz

echo "cd -" >>  $phaser_csh
echo "rm -fr ${name_c}_phaser_tmp" >>  $phaser_csh
echo "endif" >>  $phaser_csh

#execute csh
chmod +x $phaser_csh
./$phaser_csh | tee .tmp.log



echo "set phase_fom = FOM  " >> $2
echo "set phase_out = $phaser_out " >> $2
echo "set phi = PHIB  " >> $2
echo "set fom = FOM  " >> $2
echo "set last_out = $phaser_out " >> $2
echo "set phase_pro = phaser " >> $2
if ( "SAD" == $OASIS_MODE )  then
echo "set phase_phi = PHIB  " >> $2
echo "set hl_signal = 1"  >> $2
echo "set HLA = HLA" >> $2
echo "set HLB = HLB" >> $2
echo "set HLC = HLC" >> $2
echo "set HLD = HLD" >> $2 
endif
if ( "DMR" == $OASIS_MODE )  then
echo "set phase_phi = PHIB " >> $2
echo "set hl_signal = 0"  >> $2
echo "set HLA = HLA" >> $2
echo "set HLB = HLB" >> $2
echo "set HLC = HLC" >> $2
echo "set HLD = HLD" >> $2 
echo "set fof_signal = 1 " >> $2 
echo "set FOF = FWT" >> $2
endif

if ( $status != 1 ) then
echo "set phase_status = 1" >> $3
else
echo "set phase_status = 0" >> $3
endif
exit

exitphaser:
echo "set phase_status = 0" >> $3


