#!/bin/tcsh 
####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,05,19
#last Edit: 2008,05,19 
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: AutoBuild_run_1_1 log
#2: select mode
###################################################################################


if ( $2 == "cbest" ) then
  set best_cyc = `awk 'BEGIN{sig=0;best_num=-1;best_cyc=1;} /^Model obtained on cycle/{cyc=$5;} /^Residues built:/{if ( $3 >= best_num) { best_cyc= cyc;best_num=$3;}} END{printf"%d",best_cyc}' $1`
endif

if ( $2 == "dbest" ) then
  set best_cyc = `awk 'BEGIN{sig=0;best_num=-1;best_cyc=1;} /^Model obtained on cycle/{cyc=$5;} /^Residues placed:/{if ( $3 >= best_num) { best_cyc= cyc;best_num=$3;}} END{printf"%d",best_cyc}' $1`
endif

if ( $2 == "rbest" ) then
  set best_cyc = `awk 'BEGIN{sig=0;best_r=100;best_cyc=1;} /^Model obtained on cycle/{cyc=$5;} /^R and R-free:/{if ( $4 <= best_r) { best_cyc=cyc;best_r=$4;}} END{printf"%d",best_cyc}' $1`
endif
endif

if ( $2 == "rfree" ) then
  set best_cyc = `awk 'BEGIN{sig=0;best_r=100;best_cyc=1;} /^Model obtained on cycle/{cyc=$5;} /^R and R-free:/{if ( $5 <= best_r) { best_cyc=cyc;best_r=$5; }} END{printf"%d",best_cyc}' $1`
endif

if ( $2 == "score" ) then
  set best_cyc = `awk 'BEGIN{sig=0;best_score=-1;best_cyc=1;} /^Model obtained on cycle/{cyc=$5;}   /^Model-map CC:/{if ( $3 >= best_score) { best_cyc=cyc;best_score=$3;}} END{printf"%d",best_cyc}' $1`
endif

if ( $2 == "normal" ) then
  set best_cyc = `awk '/Best solution on cycle:/{print $5}' $1` 
endif


echo $best_cyc
