####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,05,20
#last Edit: 2008,05,20
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: changed parameters pool
#3: states pool
#4: dm signal
###################################################################################

source $1
source $2

echo "set build_status = 0" >> $3

set resolve_csh = ${name_c}_resolve.csh
rm -f $resolve_csh
touch  $resolve_csh
echo "#\!/bin/tcsh" >>  $resolve_csh
echo " if ( -e ${name_c}_resolve_tmp ) then " >>  $resolve_csh
echo "echo 'A resolve is running now, please check ${name_c}_resolve_tmp and remove it'" >>  $resolve_csh
echo "else" >>  $resolve_csh
echo "mkdir ${name_c}_resolve_tmp"  >>  $resolve_csh
echo "cd ${name_c}_resolve_tmp" >>  $resolve_csh
echo "phenix.resolve << EOD" >>  $resolve_csh
echo "hklin ../$last_out" >>  $resolve_csh
set lab = "FP=FP PHIB=$phi FOM=$fom "

if ( $hl_signal == 1 ) then
set lab = "${lab} HLA=$HLA HLB=$HLB HLC=$HLC HLD=$HLD"
endif

echo "LABIN ${lab}"  >>  $resolve_csh

#if ( $4 != "resolve" ) then
echo "build_only" >>  $resolve_csh
#endif
echo "hklout resolve.mtz" >>  $resolve_csh
echo "solvent_content $SOLC" >>  $resolve_csh
echo "seq_file ../resolve.seq" >>  $resolve_csh
if ( $ha_signal == "1" ) then
echo "ha_file ../$ha_pdb" >>  $resolve_csh
endif
echo "EOD" >>  $resolve_csh
echo "cp resolve.mtz ../${name_c}_resolve.mtz" >>  $resolve_csh
echo "cp resolve.pdb ../${name_c}_resolve.pdb" >>  $resolve_csh
echo "cd -" >>  $resolve_csh
echo "rm -fr ${name_c}_resolve_tmp" >>  $resolve_csh
echo "endif" >>  $resolve_csh


#execute csh
if ( -e ${name_c}_resolve_tmp ) then
  rm -fr ${name_c}_resolve_tmp
endif

chmod +x $resolve_csh
./$resolve_csh | tee .resolve_tmp.log

if ( $status != 1 ) then
echo "set build_status = 1" >> $3
else
echo "set build_status = 0" >> $3
endif

set resolve_result = `${oasisbin}/resolve_getinf.csh .resolve_tmp.log`
echo "set recommend = ( $resolve_result ) " >> $2
echo "set build_pdb_out = ${name_c}_resolve.pdb" >> $2
set build_mtz_out = ${name_c}_resolve.mtz
echo "set build_mtz_out = ${name_c}_resolve.mtz" >> $2
echo "set build_frc_out = ${name_c}_resolve.frc" >> $2
echo "set build_pro = resolve" >> $2
echo "set fom_signal = 1"  >> $2
echo "set build_fp = FP " >> $2
echo "set build_sigfp = SIGFP " >> $2
echo "set FOMM = FOMM" >> $2
echo "set fom_file = $build_mtz_out "  >> $2
#echo "set hl_signal = 1 " >> $2
#if ( $hl_signal == 1  ) then
#  echo "set hl_signal = 1 " >> $2
#  echo "set hl_file = $build_mtz_out " >> $2
#  echo "set HLA = HLAM" >> $2
#  echo "set HLB = HLBM" >> $2
#  echo "set HLC = HLCM" >> $2
#  echo "set HLD = HLDM" >> $2
#else
#  echo "set hl_signal = 0 " >> $2
#endif

echo "set fof_signal = 0 "  >> $2
source $2
set ncs_tmp = `awk 'BEGIN{n=0;}  /Transformations formatted for input to resolve:/{n++;} END{if ( n>1) n=1;print n;}'  .resolve_tmp.log`
if ( $ncs_tmp == 1 ) then
set ncs_line = ` awk 'BEGIN{n=0;} /Transformations formatted for input to resolve:/{n++;} END{print n;}' .resolve_tmp.log`
awk -v line="$ncs_line" 'BEGIN{ m_n=0;n=0;} /rota_matrix|tran_orth|Transformations formatted for input to resolve:/{if ( $1 == "Transformations" ) {n++;next;} if ( n==line ) {print $0;}}' .resolve_tmp.log > ${name_c}_ncs.log
echo "set ncs_file = ${name_c}_ncs.log"  >> $2
echo "set ncs_signal = 1"   >> $2
endif
rm -f .resolve_tmp.log


${CBIN}/coordconv XYZIN $build_pdb_out \
XYZOUT ${name_c}_tmp.ha  << + > ${name_c}_frc.log
	input PDB -
       orth 1
       output HA
       cell $CELL_A $CELL_B $CELL_C $CELL_ALPHA $CELL_BETA $CELL_GAMMA 
       end
+



awk 'BEGIN{n=0} {n++;c= toupper(substr($2,1,1));c_ha = toupper(substr($2,1,2)) ;if ( c!="C" && c!="N" && c!="O" && c!="S" && c!="D"  ||  c_ha=="SE" || c_ha=="CU"  ) { c=c_ha;} else if ( c =="D" )  { c="C";} printf "%s %d %.4f %.4f %.4f %.4f %.4f \n",c,n,$3,$4,$5,$6,$9;}' ${name_c}_tmp.ha > $build_frc_out

rm -f ${name_c}_tmp.ha

#if ( "1" == $ha_signal )  then
#	set ii = 1
#	set par_n = `awk 'BEGIN{n=0;} {n++} END{print n;}' $build_frc_out `
#	while ( $ii <= $HA_NUM )
#		@ par_n++
#		echo "$HA_TYPE[$ii] $par_n $HA_X[$ii] $HA_Y[$ii] $HA_Z[$ii] $HA_OCC[$ii] $HA_B[$ii]" >> $build_frc_out
#		@ ii++
#	end
#endif


